"use strict";

let create =  n => init => {
    let a = new Array(n);
    a.fill(init);
    return a;
};

let length =  x => x.length;

let index =  x => n => x[n];

let swap =  x => i => j => {
    let tmp = x[i];
    x[i] = x[j];
    x[j] = tmp;
    return x;
};

let append =  a1 => a2 => a1.concat(a2);

let eq =  a1 => a2 => a1.length == a2.length && a1.every((v, i) => v === a2[i]);

let split =  a => i => [a.slice(0, i), a.slice(i)];