"use strict";

// let create =  init => len => {
//     let res = new Uint32Array(len);
//     res.fill(init);
//     return res;
// };

let createL =  l => Uint32Array.from(l);

// let index =  b => n => b[n];

let upd =  b => n => v => {
    b[n] = v;
    return null;
};

let sub =  b => i => len => b.subarray(i, i + len);

let offset =  b => i => b.subarray(i, b.length);

let blit =  a => idx_a => b => idx_b => len => {
    let tmp = sub(a)(idx_a)(len);
    b.set(tmp, idx_b);
    return b;
};

let fill =  b => z => len => b.fill(z, 0, len);

// let split =  b => i => [sub(b)(0)(i), sub(b)(i)(b.length - i)];

let op_Array_Access =  b => n => index(b)(n);

let op_Array_Assignment =  b => n => v => upd(b)(n)(v);