
(function() {
    ds._o_061 = ds._o_061 || {};
    ds._o_061._o_056 = ds._o_061._o_056 || {};
    ds._o_061.algorithms = ds._o_061.algorithms || {};
    ds._o_061.algorithms._o_056 = ds._o_056= ds._o_061._o_056;

    var _v_030 = null;
    var _v_031 = false;
    var _v_032 = null;

    const _f_290 = () => {
        _v_030 = String.fromCharCode(128);
        _v_030 += ds._o_050._f_147(String.fromCharCode(0x00), 64);

        _v_032 = [
            0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5,
            0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5,
            0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3,
            0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174,
            0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc,
            0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
            0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7,
            0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967,
            0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13,
            0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85,
            0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3,
            0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
            0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5,
            0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3,
            0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208,
            0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2];

        _v_031 = true;
    }

    const _f_291 = (s, w, bytes) => {
        let t1, t2, s0, s1, ch, maj, i, a, b, c, d, e, f, g, h;
        let len = bytes.length();
        while(len >= 64) {
            for(i = 0; i < 16; ++i) {
                w[i] = bytes._f_133();
            }
            for(; i < 64; ++i) {
                t1 = w[i - 2];
                t1 =
                    ((t1 >>> 17) | (t1 << 15)) ^
                    ((t1 >>> 19) | (t1 << 13)) ^
                    (t1 >>> 10);
                t2 = w[i - 15];
                t2 =
                    ((t2 >>> 7) | (t2 << 25)) ^
                    ((t2 >>> 18) | (t2 << 14)) ^
                    (t2 >>> 3);
                w[i] = (t1 + w[i - 7] + t2 + w[i - 16]) | 0;
            }

            a = s.h0;
            b = s.h1;
            c = s.h2;
            d = s.h3;
            e = s.h4;
            f = s.h5;
            g = s.h6;
            h = s.h7;

            for(i = 0; i < 64; ++i) {
                s1 =
                    ((e >>> 6) | (e << 26)) ^
                    ((e >>> 11) | (e << 21)) ^
                    ((e >>> 25) | (e << 7));
                ch = g ^ (e & (f ^ g));
                s0 =
                    ((a >>> 2) | (a << 30)) ^
                    ((a >>> 13) | (a << 19)) ^
                    ((a >>> 22) | (a << 10));
                maj = (a & b) | (c & (a ^ b));

                t1 = h + s1 + ch + _v_032[i] + w[i];
                t2 = s0 + maj;
                h = g;
                g = f;
                f = e;
                e = (d + t1) >>> 0;
                d = c;
                c = b;
                b = a;
                a = (t1 + t2) >>> 0;
            }

            s.h0 = (s.h0 + a) | 0;
            s.h1 = (s.h1 + b) | 0;
            s.h2 = (s.h2 + c) | 0;
            s.h3 = (s.h3 + d) | 0;
            s.h4 = (s.h4 + e) | 0;
            s.h5 = (s.h5 + f) | 0;
            s.h6 = (s.h6 + g) | 0;
            s.h7 = (s.h7 + h) | 0;
            len -= 64;
        }
    }

    ds._o_061._o_056.create =  () => {

            if(!_v_031) {
                _f_290();
            }

            let _state = null;
            var _v_33 = ds._o_059._f_125();
            var _v_34 = new Array(64);
            var _v_35 = {
                algorithm: 'sha256',
                blockLength: 64,
                digestLength: 32,
                messageLength: 0,
                fullMessageLength: null,
                messageLengthSize: 8
            };

            _v_35.start = () => {
                _v_35.messageLength = 0;
                _v_35.fullMessageLength = _v_35.messageLength64 = [];
                const int32s = _v_35.messageLengthSize / 4;
                for(let i = 0; i < int32s; ++i) {
                    _v_35.fullMessageLength.push(0);
                }
                _v_33 = ds._o_059._f_125();
                _state = {
                    h0: 0x6A09E667,
                    h1: 0xBB67AE85,
                    h2: 0x3C6EF372,
                    h3: 0xA54FF53A,
                    h4: 0x510E527F,
                    h5: 0x9B05688C,
                    h6: 0x1F83D9AB,
                    h7: 0x5BE0CD19
                };
                return _v_35;
            };

            _v_35.start();

            _v_35.update = (msg, encoding) => {
                if(encoding === 'utf8') {
                    msg = ds._o_050._f_145(msg);
                }

                let len = msg.length;
                _v_35.messageLength += len;
                len = [(len / 0x100000000) >>> 0, len >>> 0];
                for(let i = _v_35.fullMessageLength.length - 1; i >= 0; --i) {
                    _v_35.fullMessageLength[i] += len[1];
                    len[1] = len[0] + ((_v_35.fullMessageLength[i] / 0x100000000) >>> 0);
                    _v_35.fullMessageLength[i] = _v_35.fullMessageLength[i] >>> 0;
                    len[0] = ((len[1] / 0x100000000) >>> 0);
                }

                _v_33._f_127(msg);

                _f_291(_state, _v_34, _v_33);

                if(_v_33.read > 2048 || _v_33.length() === 0) {
                    _v_33._f_137();
                }

                return _v_35;
            };

            _v_35.digest = () => {

                let finalBlock = ds._o_059._f_125();
                finalBlock._f_127(_v_33.bytes());

                let remaining = (
                    _v_35.fullMessageLength[_v_35.fullMessageLength.length - 1] +
                    _v_35.messageLengthSize);

                const overflow = remaining & (_v_35.blockLength - 1);
                finalBlock._f_127(_v_030.substr(0, _v_35.blockLength - overflow));

                let next, carry;
                let bits = _v_35.fullMessageLength[0] * 8;
                for(let i = 0; i < _v_35.fullMessageLength.length - 1; ++i) {
                    next = _v_35.fullMessageLength[i + 1] * 8;
                    carry = (next / 0x100000000) >>> 0;
                    bits += carry;
                    finalBlock._f_134(bits >>> 0);
                    bits = next >>> 0;
                }
                finalBlock._f_134(bits);

                let s2 = {
                    h0: _state.h0,
                    h1: _state.h1,
                    h2: _state.h2,
                    h3: _state.h3,
                    h4: _state.h4,
                    h5: _state.h5,
                    h6: _state.h6,
                    h7: _state.h7
                };
                _f_291(s2, _v_34, finalBlock);
                let rval = ds._o_059._f_125();
                rval._f_134(s2.h0);
                rval._f_134(s2.h1);
                rval._f_134(s2.h2);
                rval._f_134(s2.h3);
                rval._f_134(s2.h4);
                rval._f_134(s2.h5);
                rval._f_134(s2.h6);
                rval._f_134(s2.h7);
                return rval;
            };

            return _v_35;
        };

})();




