/**Main library**/

"use strict";

(function(root){

    root.ds = {
        _o_050: {},
        _o_051: {},
        _o_052: {},
        _o_053: {},
        _o_054: {} ,
        _o_055: {},
        _o_056: {},
        _o_057: {},
        _o_058:{},
        _o_059:{},
        _o_060:{},
        _o_061: {}
    };

})(this);
(function (ds) {
    const _c_123 = function (b) {
        let _res;
        {
                        let _self_ = this;
            const _i_154 = b => {
                _self_.data = '';
                _self_.read = 0;
                if (typeof b === 'string') {
                    _self_.data = b;
                } else if (ds._o_050._f_143(b) || ds._o_050._f_142(b)) {
                    const arr = new Uint8Array(b);
                    try {
                        _self_.data = String.fromCharCode.apply(null, arr);
                    } catch (e) {
                        for (let i = 0; i < arr.length; ++i) {
                            _self_._f_128(arr[i]);
                        }
                    }
                } else if (b instanceof _c_123 || typeof b === 'object' && typeof b.data === 'string' && typeof b.read === 'number') {
                    _self_.data = b.data;
                    _self_.read = b.read;
                }
                _self_._constructedStringLength = 0;
            };
            (_i_154(b))
        }
    };
    ds._o_059._f_123 = _c_123;
    ds._o_059._f_124 = _c_123;
    ds._o_059._f_125 = function (input, encoding) {
        encoding = encoding || 'raw';
        if (input !== undefined && encoding === 'utf8') {
            input = ds._o_050._f_145(input);
        }
        return new _c_123(input);
    };
    const _c_124 = 4096;
    _c_123.prototype._f_126 = function (x) {
        let _res;
        {
                        let _self_ = this;
            const _i_155 = x => {
                _self_._constructedStringLength += x;
                if (_self_._constructedStringLength > _c_124) {
                    _self_.data.substr(0, 1);
                    _self_._constructedStringLength = 0;
                }
            };
            (_i_155(x))
        }
    };
    _c_123.prototype._f_127 = function (bytes) {
        let _res;
        {
                        let _self_ = this;
            const _i_156 = bytes => {
                _self_.data += bytes;
                _self_._f_126(bytes.length);
                return this;
            };
            (_i_156(bytes))
        }
    };
    _c_123.prototype._f_128 = function (b) {
        let _res;
        {
                        let _self_ = this;
            const _i_157 = b => {
                return _self_._f_127(String.fromCharCode(b));
            };
            (_i_157(b))
        }
    };
    _c_123.prototype._f_129 = function () {
        let rval = '';
        for (let i = this.read; i < this.data.length; ++i) {
            let b = this.data.charCodeAt(i);
            if (b < 16) {
                rval += '0';
            }
            rval += b.toString(16);
        }
        return rval;
    };
    _c_123.prototype.length = function () {
        return this.data.length - this.read;
    };
    _c_123.prototype._f_130 = function () {
        let _res;
        {
                        let _self_ = this;
            const _i_158 = () => {
                _self_.data = '';
                _self_.read = 0;
                return this;
            };
            (_i_158())
        }
    };
    _c_123.prototype.getBytes = function (count) {
        let rval;
        if (count) {
            count = Math.min(this.length(), count);
            rval = this.data.slice(this.read, this.read + count);
            this.read += count;
        } else if (count === 0) {
            rval = '';
        } else {
            rval = this.read === 0 ? this.data : this.data.slice(this.read);
            this._f_130();
        }
        return rval;
    };
    _c_123.prototype._f_131 = function () {
        return this.data.charCodeAt(this.read++);
    };
    _c_123.prototype._f_132 = function (b, n) {
        let _res;
        {
                        let _self_ = this;
            const _i_159 = (b, n) => {
                b = String.fromCharCode(b);
                let d = _self_.data;
                while (n > 0) {
                    if (n & 1) {
                        d += b;
                    }
                    n >>>= 1;
                    if (n > 0) {
                        b += b;
                    }
                }
                _self_.data = d;
                _self_._f_126(n);
                return this;
            };
            (_i_159(b, n))
        }
    };
    _c_123.prototype._f_133 = function () {
        const rval = this.data.charCodeAt(this.read) << 24 ^ this.data.charCodeAt(this.read + 1) << 16 ^ this.data.charCodeAt(this.read + 2) << 8 ^ this.data.charCodeAt(this.read + 3);
        this.read += 4;
        return rval;
    };
    _c_123.prototype._f_134 = function (i) {
        let _res;
        {
                        let _self_ = this;
            const _i_160 = i => {
                return _self_._f_127(String.fromCharCode(i >> 24 & 255) + String.fromCharCode(i >> 16 & 255) + String.fromCharCode(i >> 8 & 255) + String.fromCharCode(i & 255));
            };
            (_i_160(i))
        }
    };
    _c_123.prototype._f_135 = function (i) {
        let _res;
        {
                        let _self_ = this;
            const _i_161 = i => {
                return _self_._f_127(String.fromCharCode(i >> 8 & 255) + String.fromCharCode(i & 255));
            };
            (_i_161(i))
        }
    };
    _c_123.prototype._f_136 = function (buffer) {
        let _res;
        {
                        let _self_ = this;
            const _i_162 = buffer => {
                return _self_._f_127(buffer.getBytes());
            };
            (_i_162(buffer))
        }
    };
    _c_123.prototype.bytes = function (count) {
        return typeof count === 'undefined' ? this.data.slice(this.read) : this.data.slice(this.read, this.read + count);
    };
    _c_123.prototype._f_137 = function () {
        let _res;
        {
                        let _self_ = this;
            const _i_163 = () => {
                if (_self_.read > 0) {
                    _self_.data = _self_.data.slice(_self_.read);
                    _self_.read = 0;
                }
                return this;
            };
            (_i_163())
        }
    };
}(ds));

(function(ds){

    (() => {
        if(typeof process !== 'undefined' && process.nextTick) {
            ds._o_050._f_140 = process.nextTick;
            if(typeof setImmediate === 'function') {
                ds._o_050._f_141 = setImmediate;
            } else {
                ds._o_050._f_141 = ds._o_050._f_140;
            }
            return;
        }

        if(typeof setImmediate === 'function') {
            ds._o_050._f_141 = () => { return setImmediate.apply(undefined, arguments); };
            ds._o_050._f_140 = (callback) => {
                return setImmediate(callback);
            };
            return;
        }

        ds._o_050._f_141 = (callback) => {
            setTimeout(callback, 0);
        };

        if(typeof window !== 'undefined' &&
            typeof window.postMessage === 'function') {
            let msg = 'ds.setImmediate';
            let callbacks = [];
            ds._o_050._f_141 = (callback) => {
                callbacks.push(callback);
                if(callbacks.length === 1) {
                    window.postMessage(msg, '*');
                }
            };
            function handler(event) {
                if(event.source === window && event.data === msg) {
                    event.stopPropagation();
                    let copy = callbacks.slice();
                    callbacks.length = 0;
                    copy.forEach(function(callback) {
                        callback();
                    });
                }
            }
            window.addEventListener('message', handler, true);
        }

        if(typeof MutationObserver !== 'undefined') {
            var now = Date.now();
            var attr = true;
            var div = document.createElement('div');
            var callbacks = [];
            new MutationObserver(function() {
                let copy = callbacks.slice();
                callbacks.length = 0;
                copy.forEach(function(callback) {
                    callback();
                });
            }).observe(div, {attributes: true});
            var oldSetImmediate = ds._o_050._f_141;
            ds._o_050._f_141 = function(callback) {
                if(Date.now() - now > 15) {
                    now = Date.now();
                    oldSetImmediate(callback);
                } else {
                    callbacks.push(callback);
                    if(callbacks.length === 1) {
                        div.setAttribute('a', attr = !attr);
                    }
                }
            };
        }

        ds._o_050._f_140 = ds._o_050._f_141;
    })();

    ds._o_050._f_143 = (x) => {
        return typeof ArrayBuffer !== 'undefined' && x instanceof ArrayBuffer;
    };

    ds._o_050._f_142 = (x) => {
        return x && utils.isArrayBuffer(x.buffer) && x.byteLength !== undefined;
    };

    ds._o_050._f_144 = Array.isArray || function(x) {
        return Object.prototype.toString.call(x) === '[object Array]';
    };

    ds._o_050._f_145 = (str) => {
        return unescape(encodeURIComponent(str));
    };

    ds._o_050._f_146 = (hex) => {
        let rval = '';
        let i = 0;
        if(hex.length & 1 == 1) {
          i = 1;
          rval += String.fromCharCode(parseInt(hex[0], 16));
        }
        for(; i < hex.length; i += 2) {
          rval += String.fromCharCode(parseInt(hex.substr(i, 2), 16));
        }
        return rval;
    };

    ds._o_050._f_147 = (c, n) => {
        let s = '';
        while(n > 0) {
            if(n & 1) {
                s += c;
            }
            n >>>= 1;
            if(n > 0) {
                c += c;
            }
        }
        return s;
    };

})(ds);
(function (ds) {
    let dbits;
    const _c_130 = 244837814094590;
    const _c_131 = (_c_130 & 16777215) == 15715070;
    const _c_132 = 52;
    const _c_133 = '0123456789abcdefghijklmnopqrstuvwxyz';
    const _c_134 = new Array();
    function _f_160(a, b, c) {
        let _res;
        {
                        let _self_ = this;
            const _i_154 = (a, b, c) => {
                _self_.data = [];
                if (a != null)
                    if ('number' == typeof a)
                        ds._o_052._f_230(a, b, c);
                    else if (b == null && 'string' != typeof a)
                        _self_._f_212(a, 256);
                    else
                        _self_._f_212(a, b);
            };
            (_i_154(a, b, c))
        }
    }
    ds._o_052._f_161 = _f_160;
    ds._o_052._f_204 = (a, b, c) => {
        let _res;
        {
            return new _f_160(a, b, c);
        }
    };
    const _f_162 = () => {
        let _res;
        {
            return new _f_160(null);
        }
    };
    ds._o_052._f_163 = () => {
        let _res;
        {
            return new _f_160(null);
        }
    };
    function _f_164(i, x, w, j, c, n) {
        let _res;
        {
                        let _self_ = this;
            const _i_155 = (i, x, w, j, c, n) => {
                while (--n >= 0) {
                    let v = x * _self_.data[i++] + w.data[j] + c;
                    c = Math.floor(v / 67108864);
                    w.data[j++] = v & 67108863;
                }
                return c;
            };
            (_i_155(i, x, w, j, c, n))
        }
    }
    function _f_202(i, x, w, j, c, n) {
        let _res;
        {
                        let _self_ = this;
            const _i_156 = (i, x, w, j, c, n) => {
                const xl = x & 32767, xh = x >> 15;
                while (--n >= 0) {
                    let l = _self_.data[i] & 32767;
                    let h = _self_.data[i++] >> 15;
                    let m = xh * l + h * xl;
                    l = xl * l + ((m & 32767) << 15) + w.data[j] + (c & 1073741823);
                    c = (l >>> 30) + (m >>> 15) + xh * h + (c >>> 30);
                    w.data[j++] = l & 1073741823;
                }
                return c;
            };
            (_i_156(i, x, w, j, c, n))
        }
    }
    function _f_165(i, x, w, j, c, n) {
        const xl = x & 16383, xh = x >> 14;
        while (--n >= 0) {
            let l = this.data[i] & 16383;
            let h = this.data[i++] >> 14;
            let m = xh * l + h * xl;
            l = xl * l + ((m & 16383) << 14) + w.data[j] + c;
            c = (l >> 28) + (m >> 14) + xh * h;
            w.data[j++] = l & 268435455;
        }
        return c;
    }
    if (typeof navigator === 'undefined') {
        _f_160.prototype.am = _f_165;
        dbits = 28;
    } else if (_c_131 && navigator.appName == 'Microsoft Internet Explorer') {
        _f_160.prototype.am = _f_202;
        dbits = 30;
    } else if (_c_131 && navigator.appName != 'Netscape') {
        _f_160.prototype.am = _f_164;
        dbits = 26;
    } else {
        _f_160.prototype.am = _f_165;
        dbits = 28;
    }
    _f_160.prototype.DB = dbits;
    _f_160.prototype._c_135 = (1 << dbits) - 1;
    _f_160.prototype._c_136 = 1 << dbits;
    _f_160.prototype._c_137 = Math.pow(2, _c_132);
    _f_160.prototype._c_138 = _c_132 - dbits;
    _f_160.prototype._c_139 = 2 * dbits - _c_132;
    let rr, vv;
    rr = '0'.charCodeAt(0);
    for (vv = 0; vv <= 9; ++vv)
        _c_134[rr++] = vv;
    rr = 'a'.charCodeAt(0);
    for (vv = 10; vv < 36; ++vv)
        _c_134[rr++] = vv;
    rr = 'A'.charCodeAt(0);
    for (vv = 10; vv < 36; ++vv)
        _c_134[rr++] = vv;
    const _f_166 = n => {
        let _res;
        {
            return _c_133.charAt(n);
        }
    };
    const _f_167 = (s, i) => {
        let _res;
        {
            const c = _c_134[s.charCodeAt(i)];
            return c == null ? -1 : c;
        }
    };
    function _f_168(r) {
        let _res;
        {
                        let _self_ = this;
            const _i_157 = r => {
                for (let i = _self_.t - 1; i >= 0; --i)
                    r.data[i] = _self_.data[i];
                r.t = _self_.t;
                r.s = _self_.s;
            };
            (_i_157(r))
        }
    }
    function _f_172(x) {
        let _res;
        {
                        let _self_ = this;
            const _i_158 = x => {
                _self_.t = 1;
                _self_.s = x < 0 ? -1 : 0;
                if (x > 0)
                    _self_.data[0] = x;
                else if (x < -1)
                    _self_.data[0] = x + _self_._c_136;
                else
                    _self_.t = 0;
            };
            (_i_158(x))
        }
    }
    const _f_173 = i => {
        let _res;
        {
            let r = _f_162();
            r._f_211(i);
            return r;
        }
    };
    function _f_174(s, b) {
        let _res;
        {
                        let _self_ = this;
            const _i_159 = (s, b) => {
                let k;
                if (b == 16)
                    k = 4;
                else if (b == 8)
                    k = 3;
                else if (b == 256)
                    k = 8;
                else if (b == 2)
                    k = 1;
                else if (b == 32)
                    k = 5;
                else if (b == 4)
                    k = 2;
                else {
                    _self_._f_229(s, b);
                    return;
                }
                _self_.t = 0;
                _self_.s = 0;
                let i = s.length, mi = false, sh = 0;
                while (--i >= 0) {
                    let x = k == 8 ? s[i] & 255 : _f_167(s, i);
                    if (x < 0) {
                        if (s.charAt(i) == '-')
                            mi = true;
                        continue;
                    }
                    mi = false;
                    if (sh == 0) {
                        _self_.data[_self_.t++] = x;
                    } else if (sh + k > _self_.DB) {
                        _self_.data[_self_.t - 1] |= (x & (1 << _self_.DB - sh) - 1) << sh;
                        _self_.data[_self_.t++] = x >> _self_.DB - sh;
                    } else
                        _self_.data[_self_.t - 1] |= x << sh;
                    sh += k;
                    if (sh >= _self_.DB)
                        sh -= _self_.DB;
                }
                if (k == 8 && (s[0] & 128) != 0) {
                    _self_.s = -1;
                    if (sh > 0)
                        _self_.data[_self_.t - 1] |= (1 << _self_.DB - sh) - 1 << sh;
                }
                _self_.clamp();
                if (mi)
                    _f_160.ZERO._f_216(this, this);
            };
            (_i_159(s, b))
        }
    }
    function _f_175() {
        let _res;
        {
                        let _self_ = this;
            const _i_160 = () => {
                let c = _self_.s & _self_._c_135;
                while (_self_.t > 0 && _self_.data[_self_.t - 1] == c)
                    --_self_.t;
            };
            (_i_160())
        }
    }
    function _f_169(b) {
        if (this.s < 0)
            return '-' + this._f_221().toString(b);
        let k;
        if (b == 16)
            k = 4;
        else if (b == 8)
            k = 3;
        else if (b == 2)
            k = 1;
        else if (b == 32)
            k = 5;
        else if (b == 4)
            k = 2;
        else
            return this.toRadix(b);
        let km = (1 << k) - 1, d, m = false, r = '', i = this.t;
        let p = this.DB - i * this.DB % k;
        if (i-- > 0) {
            if (p < this.DB && (d = this.data[i] >> p) > 0) {
                m = true;
                r = _f_166(d);
            }
            while (i >= 0) {
                if (p < k) {
                    d = (this.data[i] & (1 << p) - 1) << k - p;
                    d |= this.data[--i] >> (p += this.DB - k);
                } else {
                    d = this.data[i] >> (p -= k) & km;
                    if (p <= 0) {
                        p += this.DB;
                        --i;
                    }
                }
                if (d > 0)
                    m = true;
                if (m)
                    r += _f_166(d);
            }
        }
        return m ? r : '0';
    }
    function _f_176() {
        let _res;
        {
                        let _self_ = this;
            const _i_161 = () => {
                let r = _f_162();
                _f_160.ZERO._f_216(this, r);
                return r;
            };
            (_i_161())
        }
    }
    function _f_170() {
        return this.s < 0 ? this._f_221() : this;
    }
    function _f_177(a) {
        let _res;
        {
                        let _self_ = this;
            const _i_162 = a => {
                let r = _self_.s - a.s;
                if (r != 0)
                    return r;
                let i = _self_.t;
                r = i - a.t;
                if (r != 0)
                    return _self_.s < 0 ? -r : r;
                while (--i >= 0)
                    if ((r = _self_.data[i] - a.data[i]) != 0)
                        return r;
                return 0;
            };
            (_i_162(a))
        }
    }
    const _f_178 = x => {
        let _res;
        {
            let r = 1, t;
            if ((t = x >>> 16) != 0) {
                x = t;
                r += 16;
            }
            if ((t = x >> 8) != 0) {
                x = t;
                r += 8;
            }
            if ((t = x >> 4) != 0) {
                x = t;
                r += 4;
            }
            if ((t = x >> 2) != 0) {
                x = t;
                r += 2;
            }
            if ((t = x >> 1) != 0) {
                x = t;
                r += 1;
            }
            return r;
        }
    };
    function _f_179(n, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_163 = (n, r) => {
                let i;
                for (i = _self_.t - 1; i >= 0; --i)
                    r.data[i + n] = _self_.data[i];
                for (i = n - 1; i >= 0; --i)
                    r.data[i] = 0;
                r.t = _self_.t + n;
                r.s = _self_.s;
            };
            (_i_163(n, r))
        }
    }
    function _f_180(n, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_164 = (n, r) => {
                for (let i = n; i < _self_.t; ++i)
                    r.data[i - n] = _self_.data[i];
                r.t = Math.max(_self_.t - n, 0);
                r.s = _self_.s;
            };
            (_i_164(n, r))
        }
    }
    function _f_181(n, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_165 = (n, r) => {
                const bs = n % _self_.DB;
                const cbs = _self_.DB - bs;
                const bm = (1 << cbs) - 1;
                let ds = Math.floor(n / _self_.DB), c = _self_.s << bs & _self_._c_135, i;
                for (i = _self_.t - 1; i >= 0; --i) {
                    r.data[i + ds + 1] = _self_.data[i] >> cbs | c;
                    c = (_self_.data[i] & bm) << bs;
                }
                for (i = ds - 1; i >= 0; --i)
                    r.data[i] = 0;
                r.data[ds] = c;
                r.t = _self_.t + ds + 1;
                r.s = _self_.s;
                r.clamp();
            };
            (_i_165(n, r))
        }
    }
    function _f_182(n, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_166 = (n, r) => {
                r.s = _self_.s;
                let ds = Math.floor(n / _self_.DB);
                if (ds >= _self_.t) {
                    r.t = 0;
                    return;
                }
                const bs = n % _self_.DB;
                const cbs = _self_.DB - bs;
                let bm = (1 << bs) - 1;
                r.data[0] = _self_.data[ds] >> bs;
                for (let i = ds + 1; i < _self_.t; ++i) {
                    r.data[i - ds - 1] |= (_self_.data[i] & bm) << cbs;
                    r.data[i - ds] = _self_.data[i] >> bs;
                }
                if (bs > 0)
                    r.data[_self_.t - ds - 1] |= (_self_.s & bm) << cbs;
                r.t = _self_.t - ds;
                r.clamp();
            };
            (_i_166(n, r))
        }
    }
    function _f_183(a, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_167 = (a, r) => {
                let i = 0, c = 0, m = Math.min(a.t, _self_.t);
                while (i < m) {
                    c += _self_.data[i] - a.data[i];
                    r.data[i++] = c & _self_._c_135;
                    c >>= _self_.DB;
                }
                if (a.t < _self_.t) {
                    c -= a.s;
                    while (i < _self_.t) {
                        c += _self_.data[i];
                        r.data[i++] = c & _self_._c_135;
                        c >>= _self_.DB;
                    }
                    c += _self_.s;
                } else {
                    c += _self_.s;
                    while (i < a.t) {
                        c -= a.data[i];
                        r.data[i++] = c & _self_._c_135;
                        c >>= _self_.DB;
                    }
                    c -= a.s;
                }
                r.s = c < 0 ? -1 : 0;
                if (c < -1)
                    r.data[i++] = _self_._c_136 + c;
                else if (c > 0)
                    r.data[i++] = c;
                r.t = i;
                r.clamp();
            };
            (_i_167(a, r))
        }
    }
    function _f_184(a, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_168 = (a, r) => {
                let x = _self_.abs(), y = a.abs();
                let i = x.t;
                r.t = i + y.t;
                while (--i >= 0)
                    r.data[i] = 0;
                for (i = 0; i < y.t; ++i)
                    r.data[i + x.t] = x.am(0, y.data[i], r, i, 0, x.t);
                r.s = 0;
                r.clamp();
                if (_self_.s != a.s)
                    _f_160.ZERO._f_216(r, r);
            };
            (_i_168(a, r))
        }
    }
    function _f_185(r) {
        let _res;
        {
                        let _self_ = this;
            const _i_169 = r => {
                let x = _self_.abs();
                let i = r.t = 2 * x.t;
                while (--i >= 0)
                    r.data[i] = 0;
                for (i = 0; i < x.t - 1; ++i) {
                    let c = x.am(i, x.data[i], r, 2 * i, 0, 1);
                    if ((r.data[i + x.t] += x.am(i + 1, 2 * x.data[i], r, 2 * i + 1, c, x.t - i - 1)) >= x._c_136) {
                        r.data[i + x.t] -= x._c_136;
                        r.data[i + x.t + 1] = 1;
                    }
                }
                if (r.t > 0)
                    r.data[r.t - 1] += x.am(i, x.data[i], r, 2 * i, 0, 1);
                r.s = 0;
                r.clamp();
            };
            (_i_169(r))
        }
    }
    function _f_186(m, q, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_170 = (m, q, r) => {
                let pm = m.abs();
                if (pm.t <= 0)
                    return;
                let pt = _self_.abs();
                if (pt.t < pm.t) {
                    if (q != null)
                        q._f_211(0);
                    if (r != null)
                        _self_._f_210(r);
                    return;
                }
                if (r == null)
                    r = _f_162();
                let y = _f_162(), ts = _self_.s, ms = m.s;
                let nsh = _self_.DB - _f_178(pm.data[pm.t - 1]);
                if (nsh > 0) {
                    pm.lShiftTo(nsh, y);
                    pt.lShiftTo(nsh, r);
                } else {
                    pm._f_210(y);
                    pt._f_210(r);
                }
                let ys = y.t;
                let y0 = y.data[ys - 1];
                if (y0 == 0)
                    return;
                let yt = y0 * (1 << _self_._c_138) + (ys > 1 ? y.data[ys - 2] >> _self_._c_139 : 0);
                let d1 = _self_._c_137 / yt, d2 = (1 << _self_._c_138) / yt, e = 1 << _self_._c_139;
                let i = r.t, j = i - ys, t = q == null ? _f_162() : q;
                y._f_213(j, t);
                if (r._f_222(t) >= 0) {
                    r.data[r.t++] = 1;
                    r._f_216(t, r);
                }
                _f_160.ONE._f_213(ys, t);
                t._f_216(y, y);
                while (y.t < ys)
                    y.data[y.t++] = 0;
                while (--j >= 0) {
                    let qd = r.data[--i] == y0 ? _self_._c_135 : Math.floor(r.data[i] * d1 + (r.data[i - 1] + e) * d2);
                    if ((r.data[i] += y.am(0, qd, r, j, 0, ys)) < qd) {
                        y._f_213(j, t);
                        r._f_216(t, r);
                        while (r.data[i] < --qd)
                            r._f_216(t, r);
                    }
                }
                if (q != null) {
                    r._f_214(ys, q);
                    if (ts != ms)
                        _f_160.ZERO._f_216(q, q);
                }
                r.t = ys;
                r.clamp();
                if (nsh > 0)
                    r._f_215(nsh, r);
                if (ts < 0)
                    _f_160.ZERO._f_216(r, r);
            };
            (_i_170(m, q, r))
        }
    }
    function _f_187(a) {
        let _res;
        {
                        let _self_ = this;
            const _i_171 = a => {
                let r = _f_162();
                _self_.abs()._f_219(a, null, r);
                if (_self_.s < 0 && r._f_222(_f_160.ZERO) > 0)
                    a._f_216(r, r);
                return r;
            };
            (_i_171(a))
        }
    }
    function _f_188() {
        let _res;
        {
                        let _self_ = this;
            const _i_172 = () => {
                if (_self_.t < 1)
                    return 0;
                const x = _self_.data[0];
                if ((x & 1) == 0)
                    return 0;
                let y = x & 3;
                y = y * (2 - (x & 15) * y) & 15;
                y = y * (2 - (x & 255) * y) & 255;
                y = y * (2 - ((x & 65535) * y & 65535)) & 65535;
                y = y * (2 - x * y % _self_._c_136) % _self_._c_136;
                return y > 0 ? _self_._c_136 - y : -y;
            };
            (_i_172())
        }
    }
    function _f_189() {
        let _res;
        {
                        let _self_ = this;
            const _i_173 = () => {
                return (_self_.t > 0 ? _self_.data[0] & 1 : _self_.s) == 0;
            };
            (_i_173())
        }
    }
    function _f_190(e, z) {
        let _res;
        {
                        let _self_ = this;
            const _i_174 = (e, z) => {
                if (e > 4294967295 || e < 1)
                    return _f_160.ONE;
                let r = _f_162(), r2 = _f_162(), g = z._f_224(this), i = _f_178(e) - 1;
                g._f_210(r);
                while (--i >= 0) {
                    z._f_227(r, r2);
                    if ((e & 1 << i) > 0)
                        z._f_226(r2, g, r);
                    else {
                        let t = r;
                        r = r2;
                        r2 = t;
                    }
                }
                return z._f_225(r);
            };
            (_i_174(e, z))
        }
    }
    function _f_192(r) {
        let _res;
        {
                        let _self_ = this;
            const _i_175 = r => {
                return Math.floor(Math.LN2 * _self_.DB / Math.log(r));
            };
            (_i_175(r))
        }
    }
    function _f_193(s, b) {
        let _res;
        {
                        let _self_ = this;
            const _i_176 = (s, b) => {
                _self_._f_211(0);
                if (b == null)
                    b = 10;
                const cs = _self_._f_228(b);
                let d = Math.pow(b, cs), mi = false, j = 0, w = 0;
                for (let i = 0; i < s.length; ++i) {
                    let x = _f_167(s, i);
                    if (x < 0) {
                        if (s.charAt(i) == '-' && _self_.signum() == 0)
                            mi = true;
                        continue;
                    }
                    w = b * w + x;
                    if (++j >= cs) {
                        _self_._f_231(d);
                        _self_._f_232(w, 0);
                        j = 0;
                        w = 0;
                    }
                }
                if (j > 0) {
                    _self_._f_231(Math.pow(b, j));
                    _self_._f_232(w, 0);
                }
                if (mi)
                    _f_160.ZERO._f_216(this, this);
            };
            (_i_176(s, b))
        }
    }
    function _f_194(a, b, c) {
        let _res;
        {
                        let _self_ = this;
            const _i_177 = (a, b, c) => {
                if ('number' == typeof b) {
                    if (a < 2)
                        _self_._f_211(1);
                    else {
                        _self_._f_230(a, c);
                        if (!_self_.testBit(a - 1))
                            _self_.bitwiseTo(_f_160.ONE._f_233(a - 1), op_or, this);
                        if (_self_.isEven())
                            _self_._f_232(1, 0);
                        while (!_self_.isProbablePrime(b)) {
                            _self_._f_232(2, 0);
                            if (_self_.bitLength() > a)
                                _self_._f_216(_f_160.ONE._f_233(a - 1), this);
                        }
                    }
                } else {
                    let x = new Array(), t = a & 7;
                    x.length = (a >> 3) + 1;
                    b.nextBytes(x);
                    if (t > 0)
                        x[0] &= (1 << t) - 1;
                    else
                        x[0] = 0;
                    _self_._f_212(x, 256);
                }
            };
            (_i_177(a, b, c))
        }
    }
    function _f_195(n) {
        let _res;
        {
                        let _self_ = this;
            const _i_178 = n => {
                let r = _f_162();
                if (n < 0)
                    _self_._f_215(-n, r);
                else
                    _self_.lShiftTo(n, r);
                return r;
            };
            (_i_178(n))
        }
    }
    function _f_196(n) {
        let _res;
        {
                        let _self_ = this;
            const _i_179 = n => {
                _self_.data[_self_.t] = _self_.am(0, n - 1, this, 0, 0, _self_.t);
                ++_self_.t;
                _self_.clamp();
            };
            (_i_179(n))
        }
    }
    function _f_197(n, w) {
        let _res;
        {
                        let _self_ = this;
            const _i_180 = (n, w) => {
                if (n == 0)
                    return;
                while (_self_.t <= w)
                    _self_.data[_self_.t++] = 0;
                _self_.data[w] += n;
                while (_self_.data[w] >= _self_._c_136) {
                    _self_.data[w] -= _self_._c_136;
                    if (++w >= _self_.t)
                        _self_.data[_self_.t++] = 0;
                    ++_self_.data[w];
                }
            };
            (_i_180(n, w))
        }
    }
    function _f_171(e, m) {
        let i = e.bitLength(), k, r = _f_173(1), z;
        if (i <= 0)
            return r;
        else if (i < 18)
            k = 1;
        else if (i < 48)
            k = 3;
        else if (i < 144)
            k = 4;
        else if (i < 768)
            k = 5;
        else
            k = 6;
        if (i < 8)
            z = ds._o_060._f_240(m);
        else if (m.isEven())
            z = ds._o_060._f_241(m);
        else
            z = ds._o_060._f_242(m);
        let g = new Array(10), n = 3, k1 = k - 1, km = (1 << k) - 1;
        g[1] = z._f_224(this);
        if (k > 1) {
            let g2 = _f_162();
            z._f_227(g[1], g2);
            while (n <= km) {
                g[n] = _f_162();
                z._f_226(g2, g[n - 2], g[n]);
                n += 2;
            }
        }
        let j = e.t - 1, w, is1 = true, r2 = _f_162(), t;
        i = _f_178(e.data[j]) - 1;
        while (j >= 0) {
            if (i >= k1)
                w = e.data[j] >> i - k1 & km;
            else {
                w = (e.data[j] & (1 << i + 1) - 1) << k1 - i;
                if (j > 0)
                    w |= e.data[j - 1] >> this.DB + i - k1;
            }
            n = k;
            while ((w & 1) == 0) {
                w >>= 1;
                --n;
            }
            if ((i -= n) < 0) {
                i += this.DB;
                --j;
            }
            if (is1) {
                g[w]._f_210(r);
                is1 = false;
            } else {
                while (n > 1) {
                    z._f_227(r, r2);
                    z._f_227(r2, r);
                    n -= 2;
                }
                if (n > 0)
                    z._f_227(r, r2);
                else {
                    t = r;
                    r = r2;
                    r2 = t;
                }
                z._f_226(r2, g[w], r);
            }
            while (j >= 0 && (e.data[j] & 1 << i) == 0) {
                z._f_227(r, r2);
                t = r;
                r = r2;
                r2 = t;
                if (--i < 0) {
                    i = this.DB - 1;
                    --j;
                }
            }
        }
        return z._f_225(r);
    }
    function _f_198() {
    }
    const _f_199 = x => {
        let _res;
        {
            return x;
        }
    };
    const _f_200 = (x, y, r) => {
        let _res;
        {
            x._f_217(y, r);
        }
    };
    const _f_201 = (x, r) => {
        let _res;
        {
            x._f_218(r);
        }
    };
    _f_198.prototype._f_224 = _f_199;
    _f_198.prototype._f_225 = _f_199;
    _f_198.prototype._f_226 = _f_200;
    _f_198.prototype._f_227 = _f_201;
    _f_160.prototype._f_210 = _f_168;
    _f_160.prototype._f_211 = _f_172;
    _f_160.prototype._f_212 = _f_174;
    _f_160.prototype.clamp = _f_175;
    _f_160.prototype._f_213 = _f_179;
    _f_160.prototype._f_214 = _f_180;
    _f_160.prototype.lShiftTo = _f_181;
    _f_160.prototype._f_215 = _f_182;
    _f_160.prototype._f_216 = _f_183;
    _f_160.prototype._f_217 = _f_184;
    _f_160.prototype._f_218 = _f_185;
    _f_160.prototype._f_219 = _f_186;
    _f_160.prototype.invDigit = _f_188;
    _f_160.prototype.isEven = _f_189;
    _f_160.prototype._f_220 = _f_190;
    _f_160.prototype.toString = _f_169;
    _f_160.prototype._f_221 = _f_176;
    _f_160.prototype.abs = _f_170;
    _f_160.prototype._f_222 = _f_177;
    _f_160.prototype._f_223 = _f_187;
    _f_160.ZERO = _f_173(0);
    _f_160.ONE = _f_173(1);
    _f_160.prototype._f_228 = _f_192;
    _f_160.prototype._f_229 = _f_193;
    _f_160.prototype._f_230 = _f_194;
    _f_160.prototype._f_231 = _f_196;
    _f_160.prototype._f_232 = _f_197;
    _f_160.prototype._f_233 = _f_195;
    _f_160.prototype._f_234 = _f_171;
    return _f_160;
}(ds));
(function (ds) {
    const _c_150 = function (m) {
        let _res;
        {
                        let _self_ = this;
            const _i_190 = m => {
                _self_.m = m;
            };
            (_i_190(m))
        }
    };
    ds._o_060._f_240 = m => {
        let _res;
        {
            return new _c_150(m);
        }
    };
    function _f_243(x) {
        let _res;
        {
                        let _self_ = this;
            const _i_191 = x => {
                if (x.s < 0 || x._f_222(_self_.m) >= 0)
                    return x._f_223(_self_.m);
                else
                    return x;
            };
            (_i_191(x))
        }
    }
    const _f_249 = x => {
        let _res;
        {
            return x;
        }
    };
    function _f_250(x) {
        let _res;
        {
                        let _self_ = this;
            const _i_192 = x => {
                x._f_219(_self_.m, null, x);
            };
            (_i_192(x))
        }
    }
    function _f_251(x, y, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_193 = (x, y, r) => {
                x._f_217(y, r);
                _self_.reduce(r);
            };
            (_i_193(x, y, r))
        }
    }
    function _f_252(x, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_194 = (x, r) => {
                x._f_218(r);
                _self_.reduce(r);
            };
            (_i_194(x, r))
        }
    }
    _c_150.prototype._f_224 = _f_243;
    _c_150.prototype._f_225 = _f_249;
    _c_150.prototype.reduce = _f_250;
    _c_150.prototype._f_226 = _f_251;
    _c_150.prototype._f_227 = _f_252;
    const _c_151 = function (m) {
        let _res;
        {
                        let _self_ = this;
            const _i_195 = m => {
                _self_.r2 = ds._o_052._f_163();
                _self_.q3 = ds._o_052._f_163();
                ds._o_052._f_161.ONE._f_213(2 * m.t, _self_.r2);
                _self_.mu = _self_.r2.divide(m);
                _self_.m = m;
            };
            (_i_195(m))
        }
    };
    ds._o_060._f_241 = m => {
        let _res;
        {
            return new _c_151(m);
        }
    };
    function _f_253(x) {
        let _res;
        {
                        let _self_ = this;
            const _i_196 = x => {
                if (x.s < 0 || x.t > 2 * _self_.m.t)
                    return x._f_223(_self_.m);
                else if (x._f_222(_self_.m) < 0)
                    return x;
                else {
                    let r = ds._o_052._f_163();
                    x._f_210(r);
                    _self_.reduce(r);
                    return r;
                }
            };
            (_i_196(x))
        }
    }
    const _f_254 = x => {
        let _res;
        {
            return x;
        }
    };
    function _f_255(x) {
        let _res;
        {
                        let _self_ = this;
            const _i_197 = x => {
                x._f_214(_self_.m.t - 1, _self_.r2);
                if (x.t > _self_.m.t + 1) {
                    x.t = _self_.m.t + 1;
                    x.clamp();
                }
                _self_.mu.multiplyUpperTo(_self_.r2, _self_.m.t + 1, _self_.q3);
                _self_.m.multiplyLowerTo(_self_.q3, _self_.m.t + 1, _self_.r2);
                while (x._f_222(_self_.r2) < 0)
                    x._f_232(1, _self_.m.t + 1);
                x._f_216(_self_.r2, x);
                while (x._f_222(_self_.m) >= 0)
                    x._f_216(_self_.m, x);
            };
            (_i_197(x))
        }
    }
    function _f_256(x, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_198 = (x, r) => {
                x._f_218(r);
                _self_.reduce(r);
            };
            (_i_198(x, r))
        }
    }
    function _f_257(x, y, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_199 = (x, y, r) => {
                x._f_217(y, r);
                _self_.reduce(r);
            };
            (_i_199(x, y, r))
        }
    }
    _c_151.prototype._f_224 = _f_253;
    _c_151.prototype._f_225 = _f_254;
    _c_151.prototype.reduce = _f_255;
    _c_151.prototype._f_226 = _f_257;
    _c_151.prototype._f_227 = _f_256;
    const _c_152 = function (m) {
        let _res;
        {
                        let _self_ = this;
            const _i_200 = m => {
                _self_.m = m;
                _self_.mp = m.invDigit();
                _self_.mpl = _self_.mp & 32767;
                _self_.mph = _self_.mp >> 15;
                _self_.um = (1 << m.DB - 15) - 1;
                _self_.mt2 = 2 * m.t;
            };
            (_i_200(m))
        }
    };
    ds._o_060._f_242 = m => {
        let _res;
        {
            return new _c_152(m);
        }
    };
    function _f_244(x) {
        let r = ds._o_052._f_163();
        x.abs()._f_213(this.m.t, r);
        r._f_219(this.m, null, r);
        if (x.s < 0 && r._f_222(ds._o_052._f_161.ZERO) > 0)
            this.m._f_216(r, r);
        return r;
    }
    function _f_245(x) {
        const r = ds._o_052._f_163();
        x._f_210(r);
        this.reduce(r);
        return r;
    }
    function _f_246(x) {
        let _res;
        {
                        let _self_ = this;
            const _i_201 = x => {
                while (x.t <= _self_.mt2)
                    x.data[x.t++] = 0;
                for (let i = 0; i < _self_.m.t; ++i) {
                    let j = x.data[i] & 32767;
                    let u0 = j * _self_.mpl + ((j * _self_.mph + (x.data[i] >> 15) * _self_.mpl & _self_.um) << 15) & x._c_135;
                    j = i + _self_.m.t;
                    x.data[j] += _self_.m.am(0, u0, x, i, 0, _self_.m.t);
                    while (x.data[j] >= x._c_136) {
                        x.data[j] -= x._c_136;
                        x.data[++j]++;
                    }
                }
                x.clamp();
                x._f_214(_self_.m.t, x);
                if (x._f_222(_self_.m) >= 0)
                    x._f_216(_self_.m, x);
            };
            (_i_201(x))
        }
    }
    function _f_248(x, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_202 = (x, r) => {
                x._f_218(r);
                _self_.reduce(r);
            };
            (_i_202(x, r))
        }
    }
    function _f_247(x, y, r) {
        let _res;
        {
                        let _self_ = this;
            const _i_203 = (x, y, r) => {
                x._f_217(y, r);
                _self_.reduce(r);
            };
            (_i_203(x, y, r))
        }
    }
    _c_152.prototype._f_224 = _f_244;
    _c_152.prototype._f_225 = _f_245;
    _c_152.prototype.reduce = _f_246;
    _c_152.prototype._f_226 = _f_247;
    _c_152.prototype._f_227 = _f_248;
}(ds));

(function(ds){

    ds._o_058._O_045 = {
        _c_161: 0x00,
        _c_162: 0x40,
        _c_163: 0x80,
        _c_164: 0xC0
    };

    ds._o_058._O_046 = {
        _c_165:          0,
        _c_166:          1,
        _c_167:          2,
        _c_168:          3,
        _c_169:          4,
        _c_170:          5,
        _c_171:          6,
        _c_172:          7,
        _c_173:          8,
        _c_174:          9,
        _c_175:         10,
        _c_176:         11,
        _c_177:         12,
        _c_178:         13,
        _c_179:         16,
        _c_180:         17,
        _c_181:         19,
        _c_182:         22,
        _c_183:         23,
        _c_184:         24,
        _c_185:         30
    };

    ds._o_058._f_300 = (tagClass, type, constructed, value, options) => {
        let obj = {
            tagClass: tagClass,
            type: type,
            constructed: constructed,
            composed: constructed || ds._o_050._f_144(value),
            value: value
        };
        return obj;
    };

    ds._o_058._f_301 = (obj, options) => {
        let copy;

        if(ds._o_050._f_144(obj)) {
            copy = [];
            for(let i = 0; i < obj.length; ++i) {
                copy.push(asn1.copy(obj[i], options));
            }
            return copy;
        }

        if(typeof obj === 'string') {
            return obj;
        }

        copy = {
            tagClass: obj.tagClass,
            type: obj.type,
            constructed: obj.constructed,
            composed: obj.composed,
            value: asn1.copy(obj.value, options)
        };
        if(options && !options.excludeBitStringContents) {
            copy.bitStringContents = obj.bitStringContents;
        }
        return copy;
    };

    const _f_306 = (bytes, remaining, n) => {
        if(n > remaining) {
            let error = new Error('Too few bytes to parse DER.');
            error.available = bytes.length();
            error.remaining = remaining;
            error.requested = n;
            throw error;
        }
    }

    const _c_160 = (bytes, remaining) => {
        let b2 = bytes._f_131();
        remaining--;
        if(b2 === 0x80) {
            return undefined;
        }

        let length;
        const longForm = b2 & 0x80;
        if(!longForm) {
            length = b2;
        } else {
            let longFormBytes = b2 & 0x7F;
            _f_306(bytes, remaining, longFormBytes);
            length = bytes.getInt(longFormBytes << 3);
        }
        if(length < 0) {
            throw new Error('Negative length: ' + length);
        }
        return length;
    };

    const _f_307 = (bytes, remaining, depth, options) => {
        let start;

        _f_306(bytes, remaining, 2);

        const b1 = bytes._f_131();
        remaining--;

        let tagClass = (b1 & 0xC0);
        let type = b1 & 0x1F;

        start = bytes.length();
        let length = _c_160(bytes, remaining);
        remaining -= start - bytes.length();

        if(length !== undefined && length > remaining) {
            if(options.strict) {
                let error = new Error('Too few bytes to read ASN.1 value.');
                error.available = bytes.length();
                error.remaining = remaining;
                error.requested = length;
                throw error;
            }
            length = remaining;
        }

        let value;
        let bitStringContents;
        let constructed = ((b1 & 0x20) === 0x20);

        if(constructed) {
            value = [];
            if(length === undefined) {
                for(;;) {
                    _f_306(bytes, remaining, 2);
                    if(bytes.bytes(2) === String.fromCharCode(0, 0)) {
                        bytes.getBytes(2);
                        remaining -= 2;
                        break;
                    }
                    start = bytes.length();
                    value.push(_f_307(bytes, remaining, depth + 1, options));
                    remaining -= start - bytes.length();
                }
            } else {
                while(length > 0) {
                    start = bytes.length();
                    value.push(_f_307(bytes, length, depth + 1, options));
                    remaining -= start - bytes.length();
                    length -= start - bytes.length();
                }
            }
        }

        if(value === undefined && tagClass === ds._o_058._O_045._c_161 &&
            type === ds._o_058._O_046._c_168) {
            bitStringContents = bytes.bytes(length);
        }

        if(value === undefined && options.decodeBitStrings &&
            tagClass === ds._o_058._O_045._c_161 &&
            (type === ds._o_058._O_046._c_168 ) &&
            length > 1) {
            const savedRead = bytes.read;
            const savedRemaining = remaining;
            let unused = 0;
            if(type === ds._o_058._O_046._c_168) {
                _f_306(bytes, remaining, 1);
                unused = bytes._f_131();
                remaining--;
            }

            if(unused === 0) {
                try {
                    start = bytes.length();
                    let subOptions = {
                        verbose: options.verbose,
                        strict: true,
                        decodeBitStrings: true
                    };
                    let composed = _f_307(bytes, remaining, depth + 1, subOptions);
                    let used = start - bytes.length();
                    remaining -= used;
                    if(type == ds._o_058._O_046._c_168) {
                        used++;
                    }

                    const tc = composed.tagClass;
                    if(used === length &&
                        (tc === ds._o_058._O_045._c_161 || tc === ds._o_058._O_045._c_163)) {
                        value = [composed];
                    }
                } catch(ex) {
                }
            }
            if(value === undefined) {
                bytes.read = savedRead;
                remaining = savedRemaining;
            }
        }

        if(value === undefined) {
            if(length === undefined) {
                if(options.strict) {
                    throw new Error('Non-constructed ASN.1 object of indefinite length.');
                }
                length = remaining;
            }

            if(type === ds._o_058._O_046._c_185) {
                value = '';
                for(; length > 0; length -= 2) {
                    _f_306(bytes, remaining, 2);
                    value += String.fromCharCode(bytes.getInt16());
                    remaining -= 2;
                }
            } else {
                value = bytes.getBytes(length);
            }
        }

        let asn1Options = bitStringContents === undefined ?  null : {
            bitStringContents: bitStringContents
        };

        return ds._o_058._f_300(tagClass, type, constructed, value, asn1Options);
    }

    ds._o_058._f_302 = (obj) => {
        let bytes = ds._o_059._f_125();
        let b1 = obj.tagClass | obj.type;
        let value = ds._o_059._f_125();
        let useBitStringContents = false;

        if('bitStringContents' in obj) {
            useBitStringContents = true;
            if(obj.original) {
                useBitStringContents = ds._o_058._f_304(obj, obj.original);
            }
        }

        if(useBitStringContents) {
            value._f_127(obj.bitStringContents);
        } else if(obj.composed) {
            if(obj.constructed) {
                b1 |= 0x20;
            } else {
                value._f_128(0x00);
            }

            for(let i = 0; i < obj.value.length; ++i) {
                if(obj.value[i] !== undefined) {
                    value._f_136(ds._o_058._f_302(obj.value[i]));
                }
            }
        } else {
            if(obj.type === ds._o_058._O_046._c_185) {
                for(let i = 0; i < obj.value.length; ++i) {
                    value._f_135(obj.value.charCodeAt(i));
                }
            } else {
                if(obj.type === ds._o_058._O_046._c_167 &&
                    obj.value.length > 1 &&
                    ((obj.value.charCodeAt(0) === 0 &&
                        (obj.value.charCodeAt(1) & 0x80) === 0) ||
                        // leading 0xFF for negative integer
                        (obj.value.charCodeAt(0) === 0xFF &&
                            (obj.value.charCodeAt(1) & 0x80) === 0x80))) {
                    value._f_127(obj.value.substr(1));
                } else {
                    value._f_127(obj.value);
                }
            }
        }

        bytes._f_128(b1);
        if(value.length() <= 127) {
            bytes._f_128(value.length() & 0x7F);
        } else {
            let len = value.length();
            let lenBytes = '';
            do {
                lenBytes += String.fromCharCode(len & 0xFF);
                len = len >>> 8;
            } while(len > 0);

            bytes._f_128(lenBytes.length | 0x80);

            for(let i = lenBytes.length - 1; i >= 0; --i) {
                bytes._f_128(lenBytes.charCodeAt(i));
            }
        }

        bytes._f_136(value);
        return bytes;
    };

    ds._o_058._f_303 = (oid) => {
        let values = oid.split('.');
        let bytes = ds._o_059._f_125();
        bytes._f_128(40 * parseInt(values[0], 10) + parseInt(values[1], 10));
        let last, valueBytes, value, b;
        for(let i = 2; i < values.length; ++i) {
            last = true;
            valueBytes = [];
            value = parseInt(values[i], 10);
            do {
                b = value & 0x7F;
                value = value >>> 7;
                if(!last) {
                    b |= 0x80;
                }
                valueBytes.push(b);
                last = false;
            } while(value > 0);

            for(let n = valueBytes.length - 1; n >= 0; --n) {
                bytes._f_128(valueBytes[n]);
            }
        }
        return bytes;
    };

    ds._o_058._f_304 = (obj1, obj2, options) => {
        if(ds._o_050._f_144(obj1)) {
            if(!ds._o_050._f_144(obj2)) {
                return false;
            }
            if(obj1.length !== obj2.length) {
                return false;
            }
            for(let i = 0; i < obj1.length; ++i) {
                if(!ds._o_058._f_304(obj1[i], obj2[i])) {
                    return false;
                }
                return true;
            }
        }

        if(typeof obj1 !== typeof obj2) {
            return false;
        }

        if(typeof obj1 === 'string') {
            return obj1 === obj2;
        }

        let equal = obj1.tagClass === obj2.tagClass &&
            obj1.type === obj2.type &&
            obj1.constructed === obj2.constructed &&
            obj1.composed === obj2.composed &&
            ds._o_058._f_304(obj1.value, obj2.value);
        if(options && options.includeBitStringContents) {
            equal = equal && (obj1.bitStringContents === obj2.bitStringContents);
        }

        return equal;
    };

    ds._o_058._f_305 = (bytes, options) => {
        if(options === undefined) {
            options = {
                strict: true,
                decodeBitStrings: true
            };
        }
        if(typeof options === 'boolean') {
            options = {
                strict: options,
                decodeBitStrings: true
            };
        }
        if(!('strict' in options)) {
            options.strict = true;
        }
        if(!('decodeBitStrings' in options)) {
            options.decodeBitStrings = true;
        }

        if(typeof bytes === 'string') {
            bytes = ds._o_059._f_125(bytes);
        }

        return _f_307(bytes, bytes.length(), 0, options);
    }

})(ds);
(function() {
    ds._o_061 = ds._o_061 || {};
    ds._o_061._o_056 = ds._o_061._o_056 || {};
    ds._o_061.algorithms = ds._o_061.algorithms || {};
    ds._o_061.algorithms._o_056 = ds._o_056= ds._o_061._o_056;

    var _v_030 = null;
    var _v_031 = false;
    var _v_032 = null;

    const _f_290 = () => {
        _v_030 = String.fromCharCode(128);
        _v_030 += ds._o_050._f_147(String.fromCharCode(0x00), 64);

        _v_032 = [
            0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5,
            0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5,
            0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3,
            0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174,
            0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc,
            0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
            0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7,
            0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967,
            0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13,
            0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85,
            0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3,
            0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
            0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5,
            0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3,
            0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208,
            0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2];

        _v_031 = true;
    }

    const _f_291 = (s, w, bytes) => {
        let t1, t2, s0, s1, ch, maj, i, a, b, c, d, e, f, g, h;
        let len = bytes.length();
        while(len >= 64) {
            for(i = 0; i < 16; ++i) {
                w[i] = bytes._f_133();
            }
            for(; i < 64; ++i) {
                t1 = w[i - 2];
                t1 =
                    ((t1 >>> 17) | (t1 << 15)) ^
                    ((t1 >>> 19) | (t1 << 13)) ^
                    (t1 >>> 10);
                t2 = w[i - 15];
                t2 =
                    ((t2 >>> 7) | (t2 << 25)) ^
                    ((t2 >>> 18) | (t2 << 14)) ^
                    (t2 >>> 3);
                w[i] = (t1 + w[i - 7] + t2 + w[i - 16]) | 0;
            }

            a = s.h0;
            b = s.h1;
            c = s.h2;
            d = s.h3;
            e = s.h4;
            f = s.h5;
            g = s.h6;
            h = s.h7;

            for(i = 0; i < 64; ++i) {
                s1 =
                    ((e >>> 6) | (e << 26)) ^
                    ((e >>> 11) | (e << 21)) ^
                    ((e >>> 25) | (e << 7));
                ch = g ^ (e & (f ^ g));
                s0 =
                    ((a >>> 2) | (a << 30)) ^
                    ((a >>> 13) | (a << 19)) ^
                    ((a >>> 22) | (a << 10));
                maj = (a & b) | (c & (a ^ b));

                t1 = h + s1 + ch + _v_032[i] + w[i];
                t2 = s0 + maj;
                h = g;
                g = f;
                f = e;
                e = (d + t1) >>> 0;
                d = c;
                c = b;
                b = a;
                a = (t1 + t2) >>> 0;
            }

            s.h0 = (s.h0 + a) | 0;
            s.h1 = (s.h1 + b) | 0;
            s.h2 = (s.h2 + c) | 0;
            s.h3 = (s.h3 + d) | 0;
            s.h4 = (s.h4 + e) | 0;
            s.h5 = (s.h5 + f) | 0;
            s.h6 = (s.h6 + g) | 0;
            s.h7 = (s.h7 + h) | 0;
            len -= 64;
        }
    }

    ds._o_061._o_056.create =  () => {

            if(!_v_031) {
                _f_290();
            }

            let _state = null;
            var _v_33 = ds._o_059._f_125();
            var _v_34 = new Array(64);
            var _v_35 = {
                algorithm: 'sha256',
                blockLength: 64,
                digestLength: 32,
                messageLength: 0,
                fullMessageLength: null,
                messageLengthSize: 8
            };

            _v_35.start = () => {
                _v_35.messageLength = 0;
                _v_35.fullMessageLength = _v_35.messageLength64 = [];
                const int32s = _v_35.messageLengthSize / 4;
                for(let i = 0; i < int32s; ++i) {
                    _v_35.fullMessageLength.push(0);
                }
                _v_33 = ds._o_059._f_125();
                _state = {
                    h0: 0x6A09E667,
                    h1: 0xBB67AE85,
                    h2: 0x3C6EF372,
                    h3: 0xA54FF53A,
                    h4: 0x510E527F,
                    h5: 0x9B05688C,
                    h6: 0x1F83D9AB,
                    h7: 0x5BE0CD19
                };
                return _v_35;
            };

            _v_35.start();

            _v_35.update = (msg, encoding) => {
                if(encoding === 'utf8') {
                    msg = ds._o_050._f_145(msg);
                }

                let len = msg.length;
                _v_35.messageLength += len;
                len = [(len / 0x100000000) >>> 0, len >>> 0];
                for(let i = _v_35.fullMessageLength.length - 1; i >= 0; --i) {
                    _v_35.fullMessageLength[i] += len[1];
                    len[1] = len[0] + ((_v_35.fullMessageLength[i] / 0x100000000) >>> 0);
                    _v_35.fullMessageLength[i] = _v_35.fullMessageLength[i] >>> 0;
                    len[0] = ((len[1] / 0x100000000) >>> 0);
                }

                _v_33._f_127(msg);

                _f_291(_state, _v_34, _v_33);

                if(_v_33.read > 2048 || _v_33.length() === 0) {
                    _v_33._f_137();
                }

                return _v_35;
            };

            _v_35.digest = () => {

                let finalBlock = ds._o_059._f_125();
                finalBlock._f_127(_v_33.bytes());

                let remaining = (
                    _v_35.fullMessageLength[_v_35.fullMessageLength.length - 1] +
                    _v_35.messageLengthSize);

                const overflow = remaining & (_v_35.blockLength - 1);
                finalBlock._f_127(_v_030.substr(0, _v_35.blockLength - overflow));

                let next, carry;
                let bits = _v_35.fullMessageLength[0] * 8;
                for(let i = 0; i < _v_35.fullMessageLength.length - 1; ++i) {
                    next = _v_35.fullMessageLength[i + 1] * 8;
                    carry = (next / 0x100000000) >>> 0;
                    bits += carry;
                    finalBlock._f_134(bits >>> 0);
                    bits = next >>> 0;
                }
                finalBlock._f_134(bits);

                let s2 = {
                    h0: _state.h0,
                    h1: _state.h1,
                    h2: _state.h2,
                    h3: _state.h3,
                    h4: _state.h4,
                    h5: _state.h5,
                    h6: _state.h6,
                    h7: _state.h7
                };
                _f_291(s2, _v_34, finalBlock);
                let rval = ds._o_059._f_125();
                rval._f_134(s2.h0);
                rval._f_134(s2.h1);
                rval._f_134(s2.h2);
                rval._f_134(s2.h3);
                rval._f_134(s2.h4);
                rval._f_134(s2.h5);
                rval._f_134(s2.h6);
                rval._f_134(s2.h7);
                return rval;
            };

            return _v_35;
        };

})();




(function (ds) {
    ds._o_057.create = plugin => {
        let _res;
        {
            let _crypto = null;
            var _v_023 = {
                plugin: plugin,
                key: null,
                seed: null,
                time: null,
                reseeds: 0,
                generated: 0
            };
            let md = plugin.md;
            const _c_190 = new Array(32);
            for (let i = 0; i < 32; ++i) {
                _c_190[i] = md.create();
            }
            _v_023.pools = _c_190;
            _v_023.pool = 0;
            _v_023.generate = function (count, callback) {
                let _res;
                {
                    if (!callback) {
                        return _v_023._f_280(count);
                    }
                    var cipher = _v_023.plugin.cipher;
                    var increment = _v_023.plugin.increment;
                    var formatKey = _v_023.plugin.formatKey;
                    var formatSeed = _v_023.plugin.formatSeed;
                    var _v_017 = ds._o_059._f_125();
                    _v_023.key = null;
                    function _f_281(err) {
                        let _res;
                        {
                            if (err) {
                                return callback(err);
                            }
                            if (_v_017.length() >= count) {
                                return callback(null, _v_017.getBytes(count));
                            }
                            if (_v_023.generated > 1048575) {
                                _v_023.key = null;
                            }
                            if (_v_023.key === null) {
                                return ds._o_050._f_140(function () {
                                    let _res;
                                    {
                                        _f_283(_f_281);
                                    }
                                });
                            }
                            var _v_018 = cipher(_v_023.key, _v_023.seed);
                            _v_023.generated += _v_018.length;
                            _v_017._f_127(_v_018);
                            _v_023.key = formatKey(cipher(_v_023.key, increment(_v_023.seed)));
                            _v_023.seed = formatSeed(cipher(_v_023.key, _v_023.seed));
                            ds._o_050._f_141(_f_281);
                        }
                    }
                    _f_281();
                }
            };
            _v_023._f_280 = function (count) {
                let _res;
                {
                    let cipher = _v_023.plugin.cipher;
                    let increment = _v_023.plugin.increment;
                    let formatKey = _v_023.plugin.formatKey;
                    let formatSeed = _v_023.plugin.formatSeed;
                    _v_023.key = null;
                    let b = ds._o_059._f_125();
                    while (b.length() < count) {
                        if (_v_023.generated > 1048575) {
                            _v_023.key = null;
                        }
                        if (_v_023.key === null) {
                            _f_284();
                        }
                        let bytes = cipher(_v_023.key, _v_023.seed);
                        _v_023.generated += bytes.length;
                        b._f_127(bytes);
                        _v_023.key = formatKey(cipher(_v_023.key, increment(_v_023.seed)));
                        _v_023.seed = formatSeed(cipher(_v_023.key, _v_023.seed));
                    }
                    return b.getBytes(count);
                }
            };
            function _f_282() {
                let _res;
                {
                    let md = _v_023.plugin.md.create();
                    md.update(_v_023.pools[0].digest().getBytes());
                    _v_023.pools[0].start();
                    let k = 1;
                    for (let i = 1; i < 32; ++i) {
                        k = k === 31 ? 2147483648 : k << 2;
                        if (k % _v_023.reseeds === 0) {
                            md.update(_v_023.pools[i].digest().getBytes());
                            _v_023.pools[i].start();
                        }
                    }
                    let keyBytes = md.digest().getBytes();
                    md.start();
                    md.update(keyBytes);
                    let seedBytes = md.digest().getBytes();
                    _v_023.key = _v_023.plugin.formatKey(keyBytes);
                    _v_023.seed = _v_023.plugin.formatSeed(seedBytes);
                    _v_023.reseeds = _v_023.reseeds === 4294967295 ? 0 : _v_023.reseeds + 1;
                    _v_023.generated = 0;
                }
            }
            function _f_283(callback) {
                let _res;
                {
                    if (_v_023.pools[0].messageLength >= 32) {
                        _f_282();
                        return callback();
                    }
                    let needed = 32 - _v_023.pools[0].messageLength << 5;
                    _v_023.seedFile(needed, function (err, bytes) {
                        let _res;
                        {
                            if (err) {
                                return callback(err);
                            }
                            _v_023.collect(bytes);
                            _f_282();
                            callback();
                        }
                    });
                }
            }
            function _f_284() {
                let _res;
                {
                    if (_v_023.pools[0].messageLength >= 32) {
                        return _f_282();
                    }
                    let needed = 32 - _v_023.pools[0].messageLength << 5;
                    _v_023.collect(_v_023.seedFileSync(needed));
                    _f_282();
                }
            }
            function _f_285(needed) {
                let _res;
                {
                    let getRandomValues = null;
                    if (typeof window !== 'undefined') {
                        let _crypto = window.crypto || window.msCrypto;
                        if (_crypto && _crypto.getRandomValues) {
                            getRandomValues = function (arr) {
                                let _res;
                                {
                                    return _crypto.getRandomValues(arr);
                                }
                            };
                        }
                    }
                    let b = ds._o_059._f_125();
                    if (getRandomValues) {
                        while (b.length() < needed) {
                            let count = Math.max(1, Math.min(needed - b.length(), 65536) / 4);
                            let entropy = new Uint32Array(Math.floor(count));
                            try {
                                getRandomValues(entropy);
                                for (let i = 0; i < entropy.length; ++i) {
                                    b._f_134(entropy[i]);
                                }
                            } catch (e) {
                                if (!(typeof QuotaExceededError !== 'undefined' && e instanceof QuotaExceededError)) {
                                    throw e;
                                }
                            }
                        }
                    }
                    if (b.length() < needed) {
                        let hi, lo, next;
                        let seed = Math.floor(Math.random() * 65536);
                        while (b.length() < needed) {
                            lo = 16807 * (seed & 65535);
                            hi = 16807 * (seed >> 16);
                            lo += (hi & 32767) << 16;
                            lo += hi >> 15;
                            lo = (lo & 2147483647) + (lo >> 31);
                            seed = lo & 4294967295;
                            for (let i = 0; i < 3; ++i) {
                                next = seed >>> (i << 3);
                                next ^= Math.floor(Math.random() * 256);
                                b._f_128(String.fromCharCode(next & 255));
                            }
                        }
                    }
                    return b.getBytes(needed);
                }
            }
            if (_crypto) {
                _v_023.seedFile = function (needed, callback) {
                    let _res;
                    {
                        _crypto.randomBytes(needed, function (err, bytes) {
                            let _res;
                            {
                                if (err) {
                                    return callback(err);
                                }
                                callback(null, bytes.toString());
                            }
                        });
                    }
                };
                _v_023.seedFileSync = function (needed) {
                    let _res;
                    {
                        return _crypto.randomBytes(needed).toString();
                    }
                };
            } else {
                _v_023.seedFile = function (needed, callback) {
                    let _res;
                    {
                        try {
                            callback(null, _f_285(needed));
                        } catch (e) {
                            callback(e);
                        }
                    }
                };
                _v_023.seedFileSync = _f_285;
            }
            _v_023.collect = function (bytes) {
                let _res;
                {
                    const count = bytes.length;
                    for (let i = 0; i < count; ++i) {
                        _v_023.pools[_v_023.pool].update(bytes.substr(i, 1));
                        _v_023.pool = _v_023.pool === 31 ? 0 : _v_023.pool + 1;
                    }
                }
            };
            _v_023.collectInt = function (i, n) {
                let _res;
                {
                    let bytes = '';
                    for (let x = 0; x < n; x += 8) {
                        bytes += String.fromCharCode(i >> x & 255);
                    }
                    _v_023.collect(bytes);
                }
            };
            return _v_023;
        }
    };
}(ds));
(function (ds) {
    if (ds._o_055 && ds._o_055.getBytes) {
        ds._o_055 = ds._o_055;
        return;
    }
    (function (jQuery) {
        let _res;
        {
            var _v_025 = {};
            _v_025.md = ds._o_061._o_056;
            function _f_270() {
                let _res;
                {
                    let ctx = ds._o_057.create(_v_025);
                    ctx.getBytes = function (count, callback) {
                        let _res;
                        {
                            return ctx.generate(count, callback);
                        }
                    };
                    ctx.getBytesSync = function (count) {
                        let _res;
                        {
                            return ctx.generate(count);
                        }
                    };
                    return ctx;
                }
            }
            let _ctx = _f_270();
            let getRandomValues = null;
            if (typeof window !== 'undefined') {
                var _crypto = window.crypto || window.msCrypto;
                if (_crypto && _crypto.getRandomValues) {
                    getRandomValues = function (arr) {
                        let _res;
                        {
                            return _crypto.getRandomValues(arr);
                        }
                    };
                }
            }
            if (!ds._o_055) {
                ds._o_055 = _ctx;
            } else {
                for (let key in _ctx) {
                    ds._o_055[key] = _ctx[key];
                }
            }
        }
    }(typeof jQuery !== 'undefined' ? jQuery : null));
}(ds));
(function (ds) {
    ds._o_053.create = options => {
        let _res;
        {
            if (arguments.length === 3) {
                options = {
                    md: arguments[0],
                    mgf: arguments[1],
                    saltLength: arguments[2]
                };
            }
            var hash = options.md;
            var mgf = options.mgf;
            var hLen = hash.digestLength;
            let salt_ = options.salt || null;
            let sLen;
            if (typeof salt_ === 'string') {
                salt_ = ds._o_059._f_125(salt_);
            }
            if ('saltLength' in options) {
                sLen = options.saltLength;
            } else if (salt_ !== null) {
                sLen = salt_.length();
            } else {
                throw new Error('Salt length not specified or specific salt not given.');
            }
            if (salt_ !== null && salt_.length() !== sLen) {
                throw new Error('Given salt length does not match length of given salt.');
            }
            var prng = options.prng || ds._o_055;
            let pssobj = {};
            pssobj.encode = function (md, modBits) {
                let _res;
                {
                    let i;
                    const emBits = modBits - 1;
                    let emLen = Math.ceil(emBits / 8);
                    let mHash = md.digest().getBytes();
                    if (emLen < hLen + sLen + 2) {
                        throw new Error('Message is too long to encrypt.');
                    }
                    let salt;
                    if (salt_ === null) {
                        salt = prng.getBytesSync(sLen);
                    } else {
                        salt = salt_.bytes();
                    }
                    let m_ = new ds._o_059._f_125();
                    m_._f_132(0, 8);
                    m_._f_127(mHash);
                    m_._f_127(salt);
                    hash.start();
                    hash.update(m_.getBytes());
                    let h = hash.digest().getBytes();
                    let ps = new ds._o_059._f_125();
                    ps._f_132(0, emLen - sLen - hLen - 2);
                    ps._f_128(1);
                    ps._f_127(salt);
                    let db = ps.getBytes();
                    let maskLen = emLen - hLen - 1;
                    let dbMask = mgf.generate(h, maskLen);
                    let maskedDB = '';
                    for (i = 0; i < maskLen; i++) {
                        maskedDB += String.fromCharCode(db.charCodeAt(i) ^ dbMask.charCodeAt(i));
                    }
                    let mask = 65280 >> 8 * emLen - emBits & 255;
                    maskedDB = String.fromCharCode(maskedDB.charCodeAt(0) & ~mask) + maskedDB.substr(1);
                    return maskedDB + h + String.fromCharCode(188);
                }
            };
            pssobj.verify = function (mHash, em, modBits) {
                let _res;
                {
                    let i;
                    const emBits = modBits - 1;
                    let emLen = Math.ceil(emBits / 8);
                    em = em.substr(-emLen);
                    if (emLen < hLen + sLen + 2) {
                        throw new Error('Inconsistent parameters to PSS signature verification.');
                    }
                    if (em.charCodeAt(emLen - 1) !== 188) {
                        throw new Error('Encoded message does not end in 0xBC.');
                    }
                    let maskLen = emLen - hLen - 1;
                    let maskedDB = em.substr(0, maskLen);
                    let h = em.substr(maskLen, hLen);
                    let mask = 65280 >> 8 * emLen - emBits & 255;
                    if ((maskedDB.charCodeAt(0) & mask) !== 0) {
                        throw new Error('Bits beyond keysize not zero as expected.');
                    }
                    let dbMask = mgf.generate(h, maskLen);
                    let db = '';
                    for (i = 0; i < maskLen; i++) {
                        db += String.fromCharCode(maskedDB.charCodeAt(i) ^ dbMask.charCodeAt(i));
                    }
                    db = String.fromCharCode(db.charCodeAt(0) & ~mask) + db.substr(1);
                    let checkLen = emLen - hLen - sLen - 2;
                    for (i = 0; i < checkLen; i++) {
                        if (db.charCodeAt(i) !== 0) {
                            throw new Error('Leftmost octets not zero as expected');
                        }
                    }
                    if (db.charCodeAt(checkLen) !== 1) {
                        throw new Error('Inconsistent PSS signature, 0x01 marker not found');
                    }
                    let salt = db.substr(-sLen);
                    let m_ = new ds._o_059._f_125();
                    m_._f_132(0, 8);
                    m_._f_127(mHash);
                    m_._f_127(salt);
                    hash.start();
                    hash.update(m_.getBytes());
                    let h_ = hash.digest().getBytes();
                    return h === h_;
                }
            };
            return pssobj;
        }
    };
}(ds));
(function (ds) {
    ds._o_051._f_150 = (m, key, bt) => {
        let _res;
        {
            let eb = ds._o_059._f_125();
            const k = Math.ceil(key.n.bitLength() / 8);
            eb._f_128(0);
            eb._f_128(bt);
            const padNum = k - 3 - m.length;
            let padByte;
            if (bt === 0 || bt === 1) {
                padByte = bt === 0 ? 0 : 255;
                for (let i = 0; i < padNum; ++i) {
                    eb._f_128(padByte);
                }
            } else {
                while (padNum > 0) {
                    let numZeros = 0;
                    let padBytes = ds._o_055.getBytes(padNum);
                    for (let i = 0; i < padNum; ++i) {
                        padByte = padBytes.charCodeAt(i);
                        if (padByte === 0) {
                            ++numZeros;
                        } else {
                            eb._f_128(padByte);
                        }
                    }
                    padNum = numZeros;
                }
            }
            eb._f_128(0);
            eb._f_127(m);
            return eb;
        }
    };
    ds._o_051._f_151 = md => {
        let _res;
        {
            let oid = '2.16.840.1.101.3.4.2.1';
            let oidBytes = ds._o_058._f_303(oid).getBytes();
            var digestInfo = ds._o_058._f_300(ds._o_058._O_045._c_161, ds._o_058._O_046._c_179, true, []);
            let digestAlgorithm = ds._o_058._f_300(ds._o_058._O_045._c_161, ds._o_058._O_046._c_179, true, []);
            digestAlgorithm.value.push(ds._o_058._f_300(ds._o_058._O_045._c_161, ds._o_058._O_046._c_171, false, oidBytes));
            digestAlgorithm.value.push(ds._o_058._f_300(ds._o_058._O_045._c_161, ds._o_058._O_046._c_170, false, ''));
            let digest = ds._o_058._f_300(ds._o_058._O_045._c_161, ds._o_058._O_046._c_169, false, md.digest().getBytes());
            digestInfo.value.push(digestAlgorithm);
            digestInfo.value.push(digest);
            return ds._o_058._f_302(digestInfo).getBytes();
        }
    };
    const _c_125 = function (x, key, pub) {
        let _res;
        {
            if (pub) {
                return x._f_234(key.e, key.n);
            }
            return x._f_234(key.d, key.n);
        }
    };
    ds._o_051._f_152 = (em, key, pub, ml) => {
        let _res;
        {
            const k = Math.ceil(key.n.bitLength() / 8);
            let eb = ds._o_059._f_125(em);
            const first = eb._f_131();
            const bt = eb._f_131();
            if (first !== 0 || pub && bt !== 0 && bt !== 1 || !pub && bt != 2 || pub && bt === 0 && typeof ml === 'undefined') {
                throw new Error('Encryption block is invalid.');
            }
            let padNum = 0;
            if (bt === 0) {
                padNum = k - 3 - ml;
                if (eb._f_131() !== 0) {
                    throw new Error('Encryption block is invalid.');
                }
            } else if (bt === 1) {
                padNum = 0;
                while (eb.length() > 1) {
                    if (eb._f_131() !== 255) {
                        --eb.read;
                        break;
                    }
                    ++padNum;
                }
            } else if (bt === 2) {
                padNum = 0;
                while (eb.length() > 1) {
                    if (eb._f_131() === 0) {
                        --eb.read;
                        break;
                    }
                    ++padNum;
                }
            }
            const zero = eb._f_131();
            if (zero !== 0 || padNum !== k - 3 - eb.length()) {
                throw new Error('Encryption block is invalid.');
            }
            return eb.getBytes();
        }
    };
    ds._o_051._f_153 = (m, key, bt) => {
        let _res;
        {
            let pub = bt;
            let eb;
            const k = Math.ceil(key.n.bitLength() / 8);
            if (bt !== false && bt !== true) {
                pub = bt === 2;
                eb = ds._o_051._f_150(m, key, bt);
            } else {
                eb = ds._o_059._f_125();
                eb._f_127(m);
            }
            const x = ds._o_052._f_204(eb._f_129(), 16);
            const y = _c_125(x, key, pub);
            let yhex = y.toString(16);
            let ed = ds._o_059._f_125();
            let zeros = k - Math.ceil(yhex.length / 2);
            while (zeros > 0) {
                ed._f_128(0);
                --zeros;
            }
            ed._f_127(ds._o_050._f_146(yhex));
            return ed.getBytes();
        }
    };
    ds._o_051._f_154 = (ed, key, pub, ml) => {
        let _res;
        {
            const k = Math.ceil(key.n.bitLength() / 8);
            if (ed.length !== k) {
                let error = new Error('Encrypted message length is invalid.');
                error.length = ed.length;
                error.expected = k;
                throw error;
            }
            let y = ds._o_052._f_204(ds._o_059._f_125(ed)._f_129(), 16);
            if (y._f_222(key.n) >= 0) {
                throw new Error('Encrypted message is invalid.');
            }
            let x = _c_125(y, key, pub);
            const xhex = x.toString(16);
            let eb = ds._o_059._f_125();
            let zeros = k - Math.ceil(xhex.length / 2);
            while (zeros > 0) {
                eb._f_128(0);
                --zeros;
            }
            eb._f_127(ds._o_050._f_146(xhex));
            if (ml !== false) {
                return ds._o_051._f_152(eb.getBytes(), key, pub);
            }
            return eb.getBytes();
        }
    };
}(ds));

/** main */
(function(ds){

    ds._o_054.sign = (key, md, scheme) => {
        /*Sign */
        //console.info('**********************FFFFF inicio function sign ds, scheme: ' + JSON.stringify(scheme));
        let bt = false;
        if(typeof scheme === 'string') {
            scheme = scheme.toUpperCase();
        }
        if(scheme === undefined || scheme === 'RSASSA-PKCS1-V1_5') {
            scheme = { encode: ds._o_051._f_151 };
            bt = 0x01;
        } else if(scheme === 'NONE' || scheme === 'NULL' || scheme === null) {
            scheme = { encode: function() { return md; } };
            bt = 0x01;
        }
        let d = scheme.encode(md, key.n.bitLength());
        return ds._o_051._f_153(d, key, bt);

    };

    ds._o_054.verify =  (key, digest, signature, scheme) => {
        //console.info('********************** inicio function verify ds, scheme: ' + JSON.stringify(scheme));
        if(typeof scheme === 'string') {
            scheme = scheme.toUpperCase();
        } else if(scheme === undefined) {
            scheme = 'RSASSA-PKCS1-V1_5';
        }

        if(scheme === 'RSASSA-PKCS1-V1_5') {
            scheme = {
                verify: function(digest, d) {
                    d = ds._o_051._f_152(d, key, true);
                    let obj = ds._o_058._f_305(d);
                    return digest === obj.value[1].value;
                }
            };
        } else if(scheme === 'NONE' || scheme === 'NULL' || scheme === null) {
            scheme = {
                verify: function(digest, d) {
                    d = ds._o_051._f_152(d, key, true);
                    return digest === d;
                }
            };
        }

        let d = ds._o_051._f_154(signature, key, true, false);
        return scheme.verify(digest, d, key.n.bitLength());

    };


})(ds);"use strict";

var _Prims = {};

var Prims = _Prims;

var _Platform_Bytes = {};

var Platform_Bytes = _Platform_Bytes;
const uu___is_MD5 =  projectee => {
  let _res;
  {
    const _0_85 = projectee;
    if (_0_85._tag === "MD5") {
      _res = true;
    } else {
      const uu____6 = _0_85;
      _res = false;
    }
  }
  return _res;
};

const uu___is_SHA1 =  projectee => {
  let _res;
  {
    const _0_86 = projectee;
    if (_0_86._tag === "SHA1") {
      _res = true;
    } else {
      const uu____12 = _0_86;
      _res = false;
    }
  }
  return _res;
};

const uu___is_SHA224 =  projectee => {
  let _res;
  {
    const _0_87 = projectee;
    if (_0_87._tag === "SHA224") {
      _res = true;
    } else {
      const uu____18 = _0_87;
      _res = false;
    }
  }
  return _res;
};

const uu___is_SHA256 =  projectee => {
  let _res;
  {
    const _0_88 = projectee;
    if (_0_88._tag === "SHA256") {
      _res = true;
    } else {
      const uu____24 = _0_88;
      _res = false;
    }
  }
  return _res;
};

const uu___is_SHA384 =  projectee => {
  let _res;
  {
    const _0_89 = projectee;
    if (_0_89._tag === "SHA384") {
      _res = true;
    } else {
      const uu____30 = _0_89;
      _res = false;
    }
  }
  return _res;
};

const uu___is_SHA512 =  projectee => {
  let _res;
  {
    const _0_90 = projectee;
    if (_0_90._tag === "SHA512") {
      _res = true;
    } else {
      const uu____36 = _0_90;
      _res = false;
    }
  }
  return _res;
};

const hashSize =  uu___41_40 => {
  let _res;
  {
    const _0_91 = uu___41_40;
    if (_0_91._tag === "MD5") {
      _res = 16;
    } else {
      if (_0_91._tag === "SHA1") {
        _res = 20;
      } else {
        if (_0_91._tag === "SHA224") {
          _res = 28;
        } else {
          if (_0_91._tag === "SHA256") {
            _res = 32;
          } else {
            if (_0_91._tag === "SHA384") {
              _res = 48;
            } else {
              if (_0_91._tag === "SHA512") {
                _res = 64;
              } else {
                throw "This value doesn\'t match!";
              }
            }
          }
        }
      }
    }
  }
  return _res;
};

const hash =  alg => uu____52 => {
  throw "Not yet implemented!";
};

const hmac =  alg => uu____69 => uu____70 => {
  throw "Not yet implemented!";
};

const digest_create =  uu____76 => {
  throw "Not yet implemented!";
};

const digest_update =  uu____85 => uu____86 => {
  throw "Not yet implemented!";
};

const digest_final =  uu____91 => {
  throw "Not yet implemented!";
};

const uu___is_RSASIG =  projectee => {
  let _res;
  {
    const _0_92 = projectee;
    if (_0_92._tag === "RSASIG") {
      _res = true;
    } else {
      const uu____97 = _0_92;
      _res = false;
    }
  }
  return _res;
};

const uu___is_DSA =  projectee => {
  let _res;
  {
    const _0_93 = projectee;
    if (_0_93._tag === "DSA") {
      _res = true;
    } else {
      const uu____103 = _0_93;
      _res = false;
    }
  }
  return _res;
};

const uu___is_ECDSA =  projectee => {
  let _res;
  {
    const _0_94 = projectee;
    if (_0_94._tag === "ECDSA") {
      _res = true;
    } else {
      const uu____109 = _0_94;
      _res = false;
    }
  }
  return _res;
};

const uu___is_RSAPSS =  projectee => {
  let _res;
  {
    const _0_95 = projectee;
    if (_0_95._tag === "RSAPSS") {
      _res = true;
    } else {
      const uu____115 = _0_95;
      _res = false;
    }
  }
  return _res;
};

const uu___is_AES_128_CBC =  projectee => {
  let _res;
  {
    const _0_96 = projectee;
    if (_0_96._tag === "AES_128_CBC") {
      _res = true;
    } else {
      const uu____121 = _0_96;
      _res = false;
    }
  }
  return _res;
};

const uu___is_AES_256_CBC =  projectee => {
  let _res;
  {
    const _0_97 = projectee;
    if (_0_97._tag === "AES_256_CBC") {
      _res = true;
    } else {
      const uu____127 = _0_97;
      _res = false;
    }
  }
  return _res;
};

const uu___is_TDES_EDE_CBC =  projectee => {
  let _res;
  {
    const _0_98 = projectee;
    if (_0_98._tag === "TDES_EDE_CBC") {
      _res = true;
    } else {
      const uu____133 = _0_98;
      _res = false;
    }
  }
  return _res;
};

const uu___is_RC4_128 =  projectee => true;

const uu___is_Pad_none =  projectee => {
  let _res;
  {
    const _0_99 = projectee;
    if (_0_99._tag === "Pad_none") {
      _res = true;
    } else {
      const uu____143 = _0_99;
      _res = false;
    }
  }
  return _res;
};

const uu___is_Pad_PKCS1 =  projectee => {
  let _res;
  {
    const _0_100 = projectee;
    if (_0_100._tag === "Pad_PKCS1") {
      _res = true;
    } else {
      const uu____149 = _0_100;
      _res = false;
    }
  }
  return _res;
};

const blockSize =  uu___42_153 => {
  let _res;
  {
    const _0_101 = uu___42_153;
    if (_0_101._tag === "TDES_EDE_CBC") {
      _res = 8;
    } else {
      if (_0_101._tag === "AES_128_CBC") {
        _res = 16;
      } else {
        if (_0_101._tag === "AES_256_CBC") {
          _res = 16;
        } else {
          throw "This value doesn\'t match!";
        }
      }
    }
  }
  return _res;
};

const uu___is_AES_128_GCM =  projectee => {
  let _res;
  {
    const _0_102 = projectee;
    if (_0_102._tag === "AES_128_GCM") {
      _res = true;
    } else {
      const uu____159 = _0_102;
      _res = false;
    }
  }
  return _res;
};

const uu___is_AES_256_GCM =  projectee => {
  let _res;
  {
    const _0_103 = projectee;
    if (_0_103._tag === "AES_256_GCM") {
      _res = true;
    } else {
      const uu____165 = _0_103;
      _res = false;
    }
  }
  return _res;
};

const uu___is_CHACHA20_POLY1305 =  projectee => {
  let _res;
  {
    const _0_104 = projectee;
    if (_0_104._tag === "CHACHA20_POLY1305") {
      _res = true;
    } else {
      const uu____171 = _0_104;
      _res = false;
    }
  }
  return _res;
};

const uu___is_AES_128_CCM =  projectee => {
  let _res;
  {
    const _0_105 = projectee;
    if (_0_105._tag === "AES_128_CCM") {
      _res = true;
    } else {
      const uu____177 = _0_105;
      _res = false;
    }
  }
  return _res;
};

const uu___is_AES_256_CCM =  projectee => {
  let _res;
  {
    const _0_106 = projectee;
    if (_0_106._tag === "AES_256_CCM") {
      _res = true;
    } else {
      const uu____183 = _0_106;
      _res = false;
    }
  }
  return _res;
};

const uu___is_AES_128_CCM_8 =  projectee => {
  let _res;
  {
    const _0_107 = projectee;
    if (_0_107._tag === "AES_128_CCM_8") {
      _res = true;
    } else {
      const uu____189 = _0_107;
      _res = false;
    }
  }
  return _res;
};

const uu___is_AES_256_CCM_8 =  projectee => {
  let _res;
  {
    const _0_108 = projectee;
    if (_0_108._tag === "AES_256_CCM_8") {
      _res = true;
    } else {
      const uu____195 = _0_108;
      _res = false;
    }
  }
  return _res;
};

const aeadKeySize =  uu___43_199 => {
  let _res;
  {
    const _0_109 = uu___43_199;
    if (_0_109._tag === "AES_128_CCM") {
      _res = 16;
    } else {
      if (_0_109._tag === "AES_128_CCM_8") {
        _res = 16;
      } else {
        if (_0_109._tag === "AES_128_GCM") {
          _res = 16;
        } else {
          if (_0_109._tag === "AES_256_CCM") {
            _res = 32;
          } else {
            if (_0_109._tag === "AES_256_CCM_8") {
              _res = 32;
            } else {
              if (_0_109._tag === "AES_256_GCM") {
                _res = 32;
              } else {
                if (_0_109._tag === "CHACHA20_POLY1305") {
                  _res = 32;
                } else {
                  throw "This value doesn\'t match!";
                }
              }
            }
          }
        }
      }
    }
  }
  return _res;
};

const aeadRealIVSize =  a => 12;

const aeadTagSize =  uu___44_207 => {
  let _res;
  {
    const _0_110 = uu___44_207;
    if (_0_110._tag === "AES_128_CCM_8") {
      _res = 8;
    } else {
      if (_0_110._tag === "AES_256_CCM_8") {
        _res = 8;
      } else {
        if (_0_110._tag === "AES_128_CCM") {
          _res = 16;
        } else {
          if (_0_110._tag === "AES_256_CCM") {
            _res = 16;
          } else {
            if (_0_110._tag === "AES_128_GCM") {
              _res = 16;
            } else {
              if (_0_110._tag === "AES_256_GCM") {
                _res = 16;
              } else {
                if (_0_110._tag === "CHACHA20_POLY1305") {
                  _res = 16;
                } else {
                  throw "This value doesn\'t match!";
                }
              }
            }
          }
        }
      }
    }
  }
  return _res;
};

const aead_encryptT =  a => k => iv => ad => plain => {
  throw "Not yet implemented!";
};

const aead_encrypt =  a => k => iv => ad => plain => {
  throw "Not yet implemented!";
};

const aead_decrypt =  a => k => iv => ad => cipher => {
  throw "Not yet implemented!";
};

const block_encrypt =  uu____536 => uu____537 => uu____538 => uu____539 => {
  throw "Not yet implemented!";
};

const block_decrypt =  uu____556 => uu____557 => uu____558 => uu____559 => {
  throw "Not yet implemented!";
};

const stream_encryptor =  uu____568 => uu____569 => {
  throw "Not yet implemented!";
};

const stream_decryptor =  uu____578 => uu____579 => {
  throw "Not yet implemented!";
};

const stream_process =  uu____588 => uu____589 => {
  throw "Not yet implemented!";
};

const stream_fini =  uu____594 => {
  throw "Not yet implemented!";
};

const random =  l => {
  throw "Not yet implemented!";
};

const rsa_gen_key =  uu____621 => {
  throw "Not yet implemented!";
};

const rsa_encrypt =  uu____635 => uu____636 => uu____637 => {
  throw "Not yet implemented!";
};

const rsa_decrypt =  k => uu____655 => uu____656 => {
  throw "Not yet implemented!";
};

const rsa_sign =  uu____675 => k => uu____677 => {
  throw "Not yet implemented!";
};

const rsa_verify =  uu____697 => uu____698 => uu____699 => uu____700 => {
  throw "Not yet implemented!";
};

const dsa_gen_key =  uu____708 => {
  throw "Not yet implemented!";
};

const dsa_sign =  uu____726 => k => uu____728 => {
  throw "Not yet implemented!";
};

const dsa_verify =  uu____748 => uu____749 => uu____750 => uu____751 => {
  throw "Not yet implemented!";
};

const dh_gen_params =  uu____757 => {
  throw "Not yet implemented!";
};

const dh_gen_key =  p => {
  throw "Not yet implemented!";
};

const dh_agreement =  k => uu____778 => {
  throw "Not yet implemented!";
};

const uu___is_ECC_P256 =  projectee => {
  let _res;
  {
    const _0_111 = projectee;
    if (_0_111._tag === "ECC_P256") {
      _res = true;
    } else {
      const uu____785 = _0_111;
      _res = false;
    }
  }
  return _res;
};

const uu___is_ECC_P384 =  projectee => {
  let _res;
  {
    const _0_112 = projectee;
    if (_0_112._tag === "ECC_P384") {
      _res = true;
    } else {
      const uu____791 = _0_112;
      _res = false;
    }
  }
  return _res;
};

const uu___is_ECC_P521 =  projectee => {
  let _res;
  {
    const _0_113 = projectee;
    if (_0_113._tag === "ECC_P521") {
      _res = true;
    } else {
      const uu____797 = _0_113;
      _res = false;
    }
  }
  return _res;
};

const ec_bytelen =  uu___45_801 => {
  let _res;
  {
    const _0_114 = uu___45_801;
    if (_0_114._tag === "ECC_P256") {
      _res = 32;
    } else {
      if (_0_114._tag === "ECC_P384") {
        _res = 48;
      } else {
        if (_0_114._tag === "ECC_P521") {
          _res = 66;
        } else {
          throw "This value doesn\'t match!";
        }
      }
    }
  }
  return _res;
};

const ec_is_on_curve =  uu____869 => uu____870 => {
  throw "Not yet implemented!";
};

const ecdh_agreement =  k => uu____883 => {
  throw "Not yet implemented!";
};

const ecdsa_sign =  uu____901 => k => uu____903 => {
  throw "Not yet implemented!";
};

const ecdsa_verify =  uu____923 => uu____924 => uu____925 => uu____926 => {
  throw "Not yet implemented!";
};

const ec_gen_key =  p => {
  throw "Not yet implemented!";
};

const uu___is_KeyRSA =  projectee => {
  let _res;
  {
    const _0_115 = projectee;
    if (_0_115._tag === "KeyRSA") {
      const _0 = _0_115._0;
      _res = true;
    } else {
      const uu____952 = _0_115;
      _res = false;
    }
  }
  return _res;
};

const __proj__KeyRSA__item___0 =  projectee => {
  let _res;
  {
    const _0_116 = projectee;
    if (_0_116._tag === "KeyRSA") {
      const _0 = _0_116._0;
      _res = _0;
    } else {
      throw "This value doesn\'t match!";
    }
  }
  return _res;
};

const uu___is_KeyDSA =  projectee => {
  let _res;
  {
    const _0_117 = projectee;
    if (_0_117._tag === "KeyDSA") {
      const _0 = _0_117._0;
      _res = true;
    } else {
      const uu____970 = _0_117;
      _res = false;
    }
  }
  return _res;
};

const __proj__KeyDSA__item___0 =  projectee => {
  let _res;
  {
    const _0_118 = projectee;
    if (_0_118._tag === "KeyDSA") {
      const _0 = _0_118._0;
      _res = _0;
    } else {
      throw "This value doesn\'t match!";
    }
  }
  return _res;
};

const uu___is_KeyECDSA =  projectee => {
  let _res;
  {
    const _0_119 = projectee;
    if (_0_119._tag === "KeyECDSA") {
      const _0 = _0_119._0;
      _res = true;
    } else {
      const uu____988 = _0_119;
      _res = false;
    }
  }
  return _res;
};

const __proj__KeyECDSA__item___0 =  projectee => {
  let _res;
  {
    const _0_120 = projectee;
    if (_0_120._tag === "KeyECDSA") {
      const _0 = _0_120._0;
      _res = _0;
    } else {
      throw "This value doesn\'t match!";
    }
  }
  return _res;
};

const validate_chain =  der_list => for_signing => hostname => ca_file => {
  throw "Not yet implemented!";
};

const get_key_from_cert =  uu____1035 => {
  throw "Not yet implemented!";
};

const hash_and_sign =  k => uu____1053 => uu____1054 => {
  throw "Not yet implemented!";
};

const verify_signature =  uu____1072 => uu____1073 => tbs => sigv => {
  throw "Not yet implemented!";
};

const load_chain =  pemfile => {
  throw "Not yet implemented!";
};

const load_key =  keyfile => {
  throw "Not yet implemented!";
};"use strict";

let failwith =  x => {
  throw x;
};"use strict";

let create =  n => init => {
    let a = new Array(n);
    a.fill(init);
    return a;
};

let length =  x => x.length;

let index =  x => n => x[n];

let swap =  x => i => j => {
    let tmp = x[i];
    x[i] = x[j];
    x[j] = tmp;
    return x;
};

let append =  a1 => a2 => a1.concat(a2);

let eq =  a1 => a2 => a1.length == a2.length && a1.every((v, i) => v === a2[i]);

let split =  a => i => [a.slice(0, i), a.slice(i)];"use strict";

// let create =  init => len => {
//     let res = new Uint32Array(len);
//     res.fill(init);
//     return res;
// };

let createL =  l => Uint32Array.from(l);

// let index =  b => n => b[n];

let upd =  b => n => v => {
    b[n] = v;
    return null;
};

let sub =  b => i => len => b.subarray(i, i + len);

let offset =  b => i => b.subarray(i, b.length);

let blit =  a => idx_a => b => idx_b => len => {
    let tmp = sub(a)(idx_a)(len);
    b.set(tmp, idx_b);
    return b;
};

let fill =  b => z => len => b.fill(z, 0, len);

// let split =  b => i => [sub(b)(0)(i), sub(b)(i)(b.length - i)];

let op_Array_Access =  b => n => index(b)(n);

let op_Array_Assignment =  b => n => v => upd(b)(n)(v);"use strict";

let char_of_int =  s => { return s};"use strict";

 var _Prims = {};

//var Prims = _Prims;
const give_witness =  x => null;
const forall_intro_gtot =  f => null;

const lemma_forall_intro_gtot =  f => null;

const gtot_to_lemma =  f => x => null;

const lemma_to_squash_gtot =  f => x => null;

const forall_intro_squash_gtot =  f => null;

const forall_intro =  f => null;

const forall_intro_2 =  f => null;

const forall_intro_3 =  f => null;

const exists_intro =  witness => null;

const forall_to_exists =  f => null;

const forall_to_exists_2 =  f => null;

const impl_intro_gtot =  f => null;

const impl_intro =  f => null;

const exists_elim =  have => f => null;

const move_requires =  f => x => null;

const ghost_lemma =  f => null;

const excluded_middle =  null;"use strict";

//let read =  x => x[0];

//let op_Bang =  x => read(x);

// let write =  x => y => {
//   x[0] = y;return null;
// };

//let op_Colon_Equals =  x => y => write(x)(y);

//let alloc =  contents => [contents];

//let recall =  r => null;

//let get =  () => null;"use strict";

let emp =  null;"use strict";

let print_string =  x => {
  console.log(x);return null;
};"use strict";

let int_to_t =  s => s;"use strict";

//let int_to_t =  s => s;"use strict";

let uint8_to_uint64 =  a => a;

let uint8_to_uint63 =  a => a;
let uint8_to_uint32 =  a => a;
let uint8_to_uint16 =  a => a;

let uint16_to_uint64 =  a => a;
let uint16_to_uint63 =  a => a;
let uint16_to_uint32 =  a => a;
let uint16_to_uint8 =  a => a & 255;

let uint32_to_uint64 =  a => a;
let uint32_to_uint63 =  a => a;
let uint32_to_uint16 =  a => a & 65535;
let uint32_to_uint8 =  a => a & 255;

let uint63_to_uint64 =  a => a;
let uint63_to_uint32 =  a => a & 4294967295;
let uint63_to_uint16 =  a => a & 65535;
let uint63_to_uint8 =  a => a & 255;

let uint64_to_uint63 =  a => a;
let uint64_to_uint32 =  a => a & 4294967295;
let uint64_to_uint16 =  a => a & 65535;
let uint64_to_uint8 =  a => a & 255;

/* Ints to Ints */
let int8_to_int64 =  a => a;
let int8_to_int63 =  a => a;
let int8_to_int32 =  a => a;
let int8_to_int16 =  a => a;

let int16_to_int64 =  a => a;
let int16_to_int63 =  a => a;
let int16_to_int32 =  a => a;
let int16_to_int8 =  a => a & 255;

let int32_to_int64 =  a => a;
let int32_to_int63 =  a => a;
let int32_to_int16 =  a => a & 65535;
let int32_to_int8 =  a => a & 255;

let int63_to_int64 =  a => a;
let int63_to_int32 =  a => a & 4294967295;
let int63_to_int16 =  a => a & 65535;
let int63_to_int8 =  a => a & 255;

let int64_to_int63 =  a => a;
let int64_to_int32 =  a => a & 4294967295;
let int64_to_int16 =  a => a & 65535;
let int64_to_int8 =  a => a & 255;

/* Uints to Ints */
let uint8_to_int64 =  a => a;
let uint8_to_int63 =  a => a;
let uint8_to_int32 =  a => a;
let uint8_to_int16 =  a => a;
let uint8_to_int8 =  a => a;

let uint16_to_int64 =  a => a;
let uint16_to_int63 =  a => a;
let uint16_to_int32 =  a => a;
let uint16_to_int16 =  a => a;
let uint16_to_int8 =  a => a & 255;

let uint32_to_int64 =  a => a;
let uint32_to_int63 =  a => a;
let uint32_to_int32 =  a => a;
let uint32_to_int16 =  a => a & 65535;
let uint32_to_int8 =  a => a & 255;

let uint63_to_int64 =  a => a;
let uint63_to_int63 =  a => a;
let uint63_to_int32 =  a => a & 4294967295;
let uint63_to_int16 =  a => a & 65535;
let uint63_to_int8 =  a => a & 255;

let uint64_to_int64 =  a => a;
let uint64_to_int63 =  a => a;
let uint64_to_int32 =  a => a & 4294967295;
let uint64_to_int16 =  a => a & 65535;
let uint64_to_int8 =  a => a & 255;

/* Ints to uints */
let int8_to_uint64 =  a => a;
let int8_to_uint63 =  a => a;
let int8_to_uint32 =  a => a;
let int8_to_uint16 =  a => a;
let int8_to_uint8 =  a => a;

let int16_to_uint64 =  a => a;
let int16_to_uint63 =  a => a;
let int16_to_uint32 =  a => a;
let int16_to_uint16 =  a => a;
let int16_to_uint8 =  a => a & 255;

let int32_to_uint64 =  a => a;
let int32_to_uint63 =  a => a;
let int32_to_uint32 =  a => a;
let int32_to_uint16 =  a => a & 65535;
let int32_to_uint8 =  a => a & 255;

let int63_to_uint64 =  a => a;
let int63_to_uint63 =  a => a;
let int63_to_uint32 =  a => a & 4294967295;
let int63_to_uint16 =  a => a & 65535;
let int63_to_uint8 =  a => a & 255;

let int64_to_uint64 =  a => a;
let int64_to_uint63 =  a => a;
let int64_to_uint32 =  a => a & 4294967295;
let int64_to_uint16 =  a => a & 65535;
let int64_to_uint8 =  a => a & 255;

let uint128_to_uint64 =  a => a;
let uint64_to_uint128 =  a => a;"use strict";"use strict";

var _Prims = {};

//var Prims = _Prims;
const isEmpty =  l => {
  let _res;
  {
    const _0_6 = l;
    if (_0_6.length == 0) {
      _res = true;
    } else {
      const uu____13 = _0_6;
      _res = false;
    }
  }
  return _res;
};
const hd =  uu___24_29 => {
  let _res;
  {
    const _0_7 = uu___24_29;
    if (_0_7.length > 0) {
      const hd = _0_7[0];
      const uu____33 = _0_7.slice(1);
      _res = hd;
    } else {
      throw "This value doesn\'t match!";
    }
  }
  return _res;
};

const tail =  uu___25_50 => {
  let _res;
  {
    const _0_8 = uu___25_50;
    if (_0_8.length > 0) {
      const uu____53 = _0_8[0];
      const tl = _0_8.slice(1);
      _res = tl;
    } else {
      throw "This value doesn\'t match!";
    }
  }
  return _res;
};

const tl =  tail;

// const length =  uu___26_76 => {
//   let _res;
//   {
//     const _0_9 = uu___26_76;
//     if (_0_9.length == 0) {
//       _res = 0;
//     } else {
//       if (_0_9.length > 0) {
//         const uu____78 = _0_9[0];
//         const tl = _0_9.slice(1);
//         _res = 1 + length(tl);
//       } else {
//         throw "This value doesn\'t match!";
//       }
//     }
//   }
//   return _res;
// };

const nth =  l => n => {
  let _res;
  {
    const _0_10 = l;
    if (_0_10.length == 0) {
      _res = null;
    } else {
      if (_0_10.length > 0) {
        const hd = _0_10[0];
        const tl = _0_10.slice(1);
        {
          const _0_11 = n == 0;
          if (_0_11 == true) {
            _res = hd;
          } else {
            const uu____112 = _0_11;
            _res = nth(tl)(n - 1);
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

// const index =  l => i => {
//   let _res;
//   {
//     const _0_12 = i == 0;
//     if (_0_12 == true) {
//       _res = hd(l);
//     } else {
//       const uu____142 = _0_12;
//       _res = index(tl(l))(i - 1);
//     }
//   }
//   return _res;
// };

const count =  x => uu___27_168 => {
  let _res;
  {
    const _0_13 = uu___27_168;
    if (_0_13.length == 0) {
      _res = 0;
    } else {
      if (_0_13.length > 0) {
        const hd = _0_13[0];
        const tl = _0_13.slice(1);
        {
          const _0_14 = x == hd;
          if (_0_14 == true) {
            _res = 1 + count(x)(tl);
          } else {
            const uu____179 = _0_14;
            _res = count(x)(tl);
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const rev_acc =  l => acc => {
  let _res;
  {
    const _0_15 = l;
    if (_0_15.length == 0) {
      _res = acc;
    } else {
      if (_0_15.length > 0) {
        const hd = _0_15[0];
        const tl = _0_15.slice(1);
        _res = rev_acc(tl)([hd].concat(acc));
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const rev =  l => rev_acc(l)([]);

// const append =  x => y => {
//   let _res;
//   {
//     const _0_16 = x;
//     if (_0_16.length == 0) {
//       _res = y;
//     } else {
//       if (_0_16.length > 0) {
//         const a = _0_16[0];
//         const tl = _0_16.slice(1);
//         _res = [a].concat(append(tl)(y));
//       } else {
//         throw "This value doesn\'t match!";
//       }
//     }
//   }
//   return _res;
// };

const op_At =  x => y => append(x)(y);

const flatten =  l => {
  let _res;
  {
    const _0_17 = l;
    if (_0_17.length == 0) {
      _res = [];
    } else {
      if (_0_17.length > 0) {
        const hd = _0_17[0];
        const tl = _0_17.slice(1);
        _res = append(hd)(flatten(tl));
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const map =  f => x => {
  let _res;
  {
    const _0_18 = x;
    if (_0_18.length == 0) {
      _res = [];
    } else {
      if (_0_18.length > 0) {
        const a = _0_18[0];
        const tl = _0_18.slice(1);
        _res = [f(a)].concat(map(f)(tl));
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const mapi_init =  f => l => i => {
  let _res;
  {
    const _0_19 = l;
    if (_0_19.length == 0) {
      _res = [];
    } else {
      if (_0_19.length > 0) {
        const hd = _0_19[0];
        const tl = _0_19.slice(1);
        _res = [f(i)(hd)].concat(mapi_init(f)(tl)(i + 1));
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const mapi =  f => l => mapi_init(f)(l)(0);

const concatMap =  f => uu___28_424 => {
  let _res;
  {
    const _0_20 = uu___28_424;
    if (_0_20.length == 0) {
      _res = [];
    } else {
      if (_0_20.length > 0) {
        const a = _0_20[0];
        const tl = _0_20.slice(1);
        _res = append(f(a))(concatMap(f)(tl));
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const fold_left =  f => x => y => {
  let _res;
  {
    const _0_21 = y;
    if (_0_21.length == 0) {
      _res = x;
    } else {
      if (_0_21.length > 0) {
        const hd = _0_21[0];
        const tl = _0_21.slice(1);
        _res = fold_left(f)(f(x)(hd))(tl);
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const fold_right =  f => l => x => {
  let _res;
  {
    const _0_22 = l;
    if (_0_22.length == 0) {
      _res = x;
    } else {
      if (_0_22.length > 0) {
        const hd = _0_22[0];
        const tl = _0_22.slice(1);
        _res = f(hd)(fold_right(f)(tl)(x));
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const fold_left2 =  f => accu => l1 => l2 => {
  let _res;
  {
    const _0_23 = [l1, l2];
    if (_0_23[0].length == 0) {
      if (_0_23[1].length == 0) {
        _res = accu;
      } else {
        if (_0_23[0].length > 0) {
          const a1 = _0_23[0][0];
          const l1 = _0_23[0].slice(1);
          if (_0_23[1].length > 0) {
            const a2 = _0_23[1][0];
            const l2 = _0_23[1].slice(1);
            _res = fold_left2(f)(f(accu)(a1)(a2))(l1)(l2);
          } else {
            throw "This value doesn\'t match!";
          }
        } else {
          throw "This value doesn\'t match!";
        }
      }
    } else {
      if (_0_23[0].length > 0) {
        const a1 = _0_23[0][0];
        const l1 = _0_23[0].slice(1);
        if (_0_23[1].length > 0) {
          const a2 = _0_23[1][0];
          const l2 = _0_23[1].slice(1);
          _res = fold_left2(f)(f(accu)(a1)(a2))(l1)(l2);
        } else {
          throw "This value doesn\'t match!";
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const mem =  x => uu___29_611 => {
  let _res;
  {
    const _0_24 = uu___29_611;
    if (_0_24.length == 0) {
      _res = false;
    } else {
      if (_0_24.length > 0) {
        const hd = _0_24[0];
        const tl = _0_24.slice(1);
        {
          const _0_25 = hd == x;
          if (_0_25 == true) {
            _res = true;
          } else {
            const uu____619 = _0_25;
            _res = mem(x)(tl);
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const memP =  x => l => null;

const contains =  uu____658 => mem;

const existsb =  f => l => {
  let _res;
  {
    const _0_26 = l;
    if (_0_26.length == 0) {
      _res = false;
    } else {
      if (_0_26.length > 0) {
        const hd = _0_26[0];
        const tl = _0_26.slice(1);
        {
          const _0_27 = f(hd);
          if (_0_27 == true) {
            _res = true;
          } else {
            const uu____689 = _0_27;
            _res = existsb(f)(tl);
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const find =  f => l => {
  let _res;
  {
    const _0_28 = l;
    if (_0_28.length == 0) {
      _res = null;
    } else {
      if (_0_28.length > 0) {
        const hd = _0_28[0];
        const tl = _0_28.slice(1);
        {
          const _0_29 = f(hd);
          if (_0_29 == true) {
            _res = hd;
          } else {
            const uu____730 = _0_29;
            _res = find(f)(tl);
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const filter =  f => uu___30_784 => {
  let _res;
  {
    const _0_30 = uu___30_784;
    if (_0_30.length == 0) {
      _res = [];
    } else {
      if (_0_30.length > 0) {
        const hd = _0_30[0];
        const tl = _0_30.slice(1);
        {
          const _0_31 = f(hd);
          if (_0_31 == true) {
            _res = [hd].concat(filter(f)(tl));
          } else {
            const uu____796 = _0_31;
            _res = filter(f)(tl);
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const mem_filter =  f => l => x => null;

const mem_filter_forall =  f => l => null;

const for_all =  f => l => {
  let _res;
  {
    const _0_32 = l;
    if (_0_32.length == 0) {
      _res = true;
    } else {
      if (_0_32.length > 0) {
        const hd = _0_32[0];
        const tl = _0_32.slice(1);
        {
          const _0_33 = f(hd);
          if (_0_33 == true) {
            _res = for_all(f)(tl);
          } else {
            const uu____902 = _0_33;
            _res = false;
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const collect =  f => l => {
  let _res;
  {
    const _0_34 = l;
    if (_0_34.length == 0) {
      _res = [];
    } else {
      if (_0_34.length > 0) {
        const hd = _0_34[0];
        const tl = _0_34.slice(1);
        _res = append(f(hd))(collect(f)(tl));
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const tryFind =  p => l => {
  let _res;
  {
    const _0_35 = l;
    if (_0_35.length == 0) {
      _res = null;
    } else {
      if (_0_35.length > 0) {
        const hd = _0_35[0];
        const tl = _0_35.slice(1);
        {
          const _0_36 = p(hd);
          if (_0_36 == true) {
            _res = hd;
          } else {
            const uu____968 = _0_36;
            _res = tryFind(p)(tl);
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const tryPick =  f => l => {
  let _res;
  {
    const _0_37 = l;
    if (_0_37.length == 0) {
      _res = null;
    } else {
      if (_0_37.length > 0) {
        const hd = _0_37[0];
        const tl = _0_37.slice(1);
        {
          const _0_38 = f(hd);
          if (_0_38 != null) {
            const x = _0_38;
            _res = x;
          } else {
            if (_0_38 == null) {
              _res = tryPick(f)(tl);
            } else {
              throw "This value doesn\'t match!";
            }
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const choose =  f => l => {
  let _res;
  {
    const _0_39 = l;
    if (_0_39.length == 0) {
      _res = [];
    } else {
      if (_0_39.length > 0) {
        const hd = _0_39[0];
        const tl = _0_39.slice(1);
        {
          const _0_40 = f(hd);
          if (_0_40 != null) {
            const x = _0_40;
            _res = [x].concat(choose(f)(tl));
          } else {
            if (_0_40 == null) {
              _res = choose(f)(tl);
            } else {
              throw "This value doesn\'t match!";
            }
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const partition =  f => uu___31_1071 => {
  let _res;
  {
    const _0_41 = uu___31_1071;
    if (_0_41.length == 0) {
      _res = [[], []];
    } else {
      if (_0_41.length > 0) {
        const hd = _0_41[0];
        const tl = _0_41.slice(1);
        {
          const _0_42 = partition(f)(tl);
          const l1 = _0_42[0];
          const l2 = _0_42[1];
          {
            const _0_43 = f(hd);
            if (_0_43 == true) {
              _res = [[hd].concat(l1), l2];
            } else {
              const uu____1096 = _0_43;
              _res = [l1, [hd].concat(l2)];
            }
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const subset =  la => lb => {
  let _res;
  {
    const _0_44 = la;
    if (_0_44.length == 0) {
      _res = true;
    } else {
      if (_0_44.length > 0) {
        const h = _0_44[0];
        const tl = _0_44.slice(1);
        _res = mem(h)(lb) && subset(tl)(lb);
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const noRepeats =  la => {
  let _res;
  {
    const _0_45 = la;
    if (_0_45.length == 0) {
      _res = true;
    } else {
      if (_0_45.length > 0) {
        const h = _0_45[0];
        const tl = _0_45.slice(1);
        _res = !mem(h)(tl) && noRepeats(tl);
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const assoc =  x => uu___32_1183 => {
  let _res;
  {
    const _0_46 = uu___32_1183;
    if (_0_46.length == 0) {
      _res = null;
    } else {
      if (_0_46.length > 0) {
        const x_ = _0_46[0][0];
        const y = _0_46[0][1];
        const tl = _0_46.slice(1);
        {
          const _0_47 = x == x_;
          if (_0_47 == true) {
            _res = y;
          } else {
            const uu____1203 = _0_47;
            _res = assoc(x)(tl);
          }
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

// const split =  l => {
//   let _res;
//   {
//     const _0_48 = l;
//     if (_0_48.length == 0) {
//       _res = [[], []];
//     } else {
//       if (_0_48.length > 0) {
//         const hd1 = _0_48[0][0];
//         const hd2 = _0_48[0][1];
//         const tl = _0_48.slice(1);
//         {
//           const _0_49 = split(tl);
//           const tl1 = _0_49[0];
//           const tl2 = _0_49[1];
//           _res = [[hd1].concat(tl1), [hd2].concat(tl2)];
//         }
//       } else {
//         throw "This value doesn\'t match!";
//       }
//     }
//   }
//   return _res;
// };

const unzip =  uu____1273 => split;

const unzip3 =  l => {
  let _res;
  {
    const _0_50 = l;
    if (_0_50.length == 0) {
      _res = [[], [], []];
    } else {
      if (_0_50.length > 0) {
        const hd1 = _0_50[0][0];
        const hd2 = _0_50[0][1];
        const hd3 = _0_50[0][2];
        const tl = _0_50.slice(1);
        {
          const _0_51 = unzip3(tl);
          const tl1 = _0_51[0];
          const tl2 = _0_51[1];
          const tl3 = _0_51[2];
          _res = [[hd1].concat(tl1), [hd2].concat(tl2), [hd3].concat(tl3)];
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const partition_length =  f => l => null;

const bool_of_compare =  f => x => y => f(x)(y) > 0;

const compare_of_bool =  rel => x => y => {
  let _res;
  {
    const _0_52 = rel(x)(y);
    if (_0_52 == true) {
      _res = 1;
    } else {
      const uu____1443 = _0_52;
      {
        const _0_53 = x == y;
        if (_0_53 == true) {
          _res = 0;
        } else {
          const uu____1445 = _0_53;
          _res = -1;
        }
      }
    }
  }
  return _res;
};

const sortWith =  f => uu___33_1474 => {
  let _res;
  {
    const _0_54 = uu___33_1474;
    if (_0_54.length == 0) {
      _res = [];
    } else {
      if (_0_54.length > 0) {
        const pivot = _0_54[0];
        const tl = _0_54.slice(1);
        {
          const _0_55 = partition(bool_of_compare(f)(pivot))(tl);
          const hi = _0_55[0];
          const lo = _0_55[1];
          _res = append(sortWith(f)(lo))([pivot].concat(sortWith(f)(hi)));
        }
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const test_sort = null;"use strict";

var _FStar_List_Tot_Base = {};

//var FStar_List_Tot_Base = _FStar_List_Tot_Base;

var _Prims = {};

//var Prims = _Prims;
const mem_empty =  x => null;

const mem_existsb =  f => xs => null;

const rev_acc_length =  l => acc => null;

const rev_length =  l => null;

const rev_acc_mem =  l => acc => x => null;

const rev_mem =  l => x => null;

const append_nil_l =  l => null;

const append_l_nil =  uu___34_166 => null;

const append_cons_l =  hd => tl => l => null;

const append_l_cons =  hd => tl => l => null;

const append_assoc =  l1 => l2 => l3 => null;

const append_length =  l1 => l2 => null;

const append_mem =  l1 => l2 => a => null;

const append_mem_forall =  l1 => l2 => null;

const append_count =  l1 => l2 => a => null;

const append_count_forall =  l1 => l2 => null;

const append_eq_nil =  l1 => l2 => null;

const append_eq_singl =  l1 => l2 => x => null;

const append_inv_head =  l => l1 => l2 => null;

const append_inv_tail =  l => l1 => l2 => null;

const rev_ =  uu___35_579 => {
  let _res;
  {
    const _0_56 = uu___35_579;
    if (_0_56.length == 0) {
      _res = [];
    } else {
      if (_0_56.length > 0) {
        const hd = _0_56[0];
        const tl = _0_56.slice(1);
        _res = FStar_List_Tot_Base.op_At(rev_(tl))([hd].concat([]));
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const rev_T =  uu____593 => rev_;

const rev_acc_rev_ =  l => acc => null;

const rev_rev_ =  l => null;

const rev__append =  l1 => l2 => null;

const rev_append =  l1 => l2 => null;

const rev__involutive =  uu___36_683 => null;

const rev_involutive =  l => null;

const rev__list_ind =  p => uu___37_723 => null;

const rev_ind =  p => l => null;

const map_lemma =  f => l => null;

const partition_mem =  f => l => x => null;

const partition_mem_forall =  f => l => null;

const partition_mem_p_forall =  p => l => null;

const partition_count =  f => l => x => null;

const partition_count_forall =  f => l => null;

const sortWith_permutation =  f => l => null;

const sorted =  f => uu___38_1066 => {
  let _res;
  {
    const _0_57 = uu___38_1066;
    if (_0_57.length == 0) {
      _res = true;
    } else {
      if (_0_57.length > 0) {
        if (_0_57.slice(1).length == 0) {
          _res = true;
        } else {
          if (_0_57.length > 0) {
            const x = _0_57[0];
            if (_0_57.slice(1).length > 0) {
              const y = _0_57.slice(1)[0];
              const tl = _0_57.slice(1).slice(1);
              _res = f(x)(y) && sorted(f)([y].concat(tl));
            } else {
              throw "This value doesn\'t match!";
            }
          } else {
            throw "This value doesn\'t match!";
          }
        }
      } else {
        if (_0_57.length > 0) {
          const x = _0_57[0];
          if (_0_57.slice(1).length > 0) {
            const y = _0_57.slice(1)[0];
            const tl = _0_57.slice(1).slice(1);
            _res = f(x)(y) && sorted(f)([y].concat(tl));
          } else {
            throw "This value doesn\'t match!";
          }
        } else {
          throw "This value doesn\'t match!";
        }
      }
    }
  }
  return _res;
};

const append_sorted =  f => l1 => l2 => pivot => null;

const sortWith_sorted =  f => l => null;

const mem_memP =  x => l => null;

const memP_empty =  x => null;

const memP_existsb =  f => xs => null;

const fold_left_invar =  f => l => p => null;

const fold_left_map =  f_aba => f_bc => f_aca => l => null;

const map_append =  f => l1 => l2 => null;

const fold_left_append =  f => l1 => l2 => null;

const fold_left_monoid =  opA => zeroA => l => null;

const fold_left_append_monoid =  f => z => l1 => l2 => null;

const index_extensionality_aux = l1 => l2 => l_len => l_index => null;
const index_extensionality =  l1 => l2 => null;// "use strict";

var _FStar_CommonST = {};

var FStar_CommonST = _FStar_CommonST;
let read =  FStar_CommonST.read;

let op_Bang =  FStar_CommonST.op_Bang;
let write =  FStar_CommonST.write;
let op_Colon_Equals =  FStar_CommonST.op_Colon_Equals;
let alloc =  FStar_CommonST.alloc;

let recall =  FStar_CommonST.recall;
let get =  FStar_CommonST.get;

let push_frame =  () => null;
let pop_frame =  () => null;"use strict";

var _FStar_Array = {};

var FStar_Array = _FStar_Array;
//let create =  FStar_Array.create;

//let append =  FStar_Array.append;
//let length =  FStar_Array.length;
//let index =  FStar_Array.index;
//let eq =  FStar_Array.eq;
let op_At_Bar =  FStar_Array.append;

let createEmpty =  () => [];

// let upd =  s => n => v => {
// 	s[n] = v;
// 	return s;
// };

let slice =  s => i => j => s.slice(i, i + j);"use strict";

var _FStar_Array = {};

//var FStar_Array = _FStar_Array;
//let split =  FStar_Array.split;"use strict";

 //var _FStar_List_Tot_Base = {};

//var FStar_List_Tot_Base = _FStar_List_Tot_Base;

 var _Prims = {};

//var Prims = _Prims;
const uu___is_MkSeq = projectee => true;
const __proj__MkSeq__item__l = projectee => {
  let _res;
  {
    const _0_58 = projectee;
    if (_0_58._tag === "MkSeq") {
      const l = _0_58._0;
      _res = l;
    } else {
      throw "This value doesn\'t match!";
    }
  }
  return _res;
};
//const length =  s => FStar_List_Tot_Base.length(__proj__MkSeq__item__l(s));

//const index =  s => i => FStar_List_Tot_Base.index(__proj__MkSeq__item__l(s))(i);

const cons = x => s => ({
  _tag: "MkSeq",
  _0: [x].concat(__proj__MkSeq__item__l(s))
});
//const hd = s => FStar_List_Tot_Base.hd(__proj__MkSeq__item__l(s));
// const tl = s => ({
//   _tag: "MkSeq",
//   _0: FStar_List_Tot_Base.tl(__proj__MkSeq__item__l(s))
// });
// const create =  len => v => {
//   let _res;
//   {
//     const _0_59 = len == 0;
//     if (_0_59 == true) {
//       _res = {
//         _tag: "MkSeq",
//         _0: []
//       };
//     } else {
//       const uu____144 = _0_59;
//       _res = cons(v)(create(len - 1)(v));
//     }
//   }
//   return _res;
// };

const init =  len => contents => {
  let _res;
  {
    const _0_60 = len == 0;
    if (_0_60 == true) {
      _res = {
        _tag: "MkSeq",
        _0: []
      };
    } else {
      const uu____184 = _0_60;
      _res = cons(contents(0))(init(len - 1)(contents));
    }
  }
  return _res;
};

const of_list =  l => ({
  _tag: "MkSeq",
  _0: l
});

const lemma_of_list_length =  s => l => null;

const lemma_of_list =  s => l => i => null;

const exFalso0 = n => null;
// const createEmpty =  uu____272 => ({
//   _tag: "MkSeq",
//   _0: []
// });

// const upd =  s => n => v => {
//   let _res;
//   {
//     const _0_61 = n == 0;
//     if (_0_61 == true) {
//       _res = cons(v)(tl(s));
//     } else {
//       const uu____306 = _0_61;
//       _res = cons(hd(s))(upd(tl(s))(n - 1)(v));
//     }
//   }
//   return _res;
// };

// const append =  s1 => s2 => ({
//   _tag: "MkSeq",
//   _0: FStar_List_Tot_Base.append(__proj__MkSeq__item__l(s1))(__proj__MkSeq__item__l(s2))
// });

//const op_At_Bar =  s1 => s2 => append(s1)(s2);

// const slice =  s => i => j => {
//   let _res;
//   {
//     const _0_62 = i > 0;
//     if (_0_62 == true) {
//       _res = slice(tl(s))(i - 1)(j - 1);
//     } else {
//       const uu____393 = _0_62;
//       {
//         const _0_63 = j == 0;
//         if (_0_63 == true) {
//           _res = {
//             _tag: "MkSeq",
//             _0: []
//           };
//         } else {
//           const uu____397 = _0_63;
//           _res = cons(hd(s))(slice(tl(s))(i)(j - 1));
//         }
//       }
//     }
//   }
//   return _res;
// };

const lemma_create_len =  n => i => null;

const lemma_init_len =  n => contents => null;

const lemma_len_upd =  n => v => s => null;

const lemma_len_append =  s1 => s2 => null;

const lemma_len_slice =  s => i => j => null;

const lemma_index_create =  n => v => i => null;

const lemma_index_upd1 =  s => n => v => null;

const lemma_index_upd2 =  s => n => v => i => null;

const lemma_index_app1 =  s1 => s2 => i => null;

const lemma_index_app2 =  s1 => s2 => i => null;

const lemma_index_slice =  s => i => j => k => null;

const hasEq_lemma =  null;

const eq_i = s1 => s2 => i => {
  let _res;
  {
    const _0_64 = i == length(s1);
    if (_0_64 == true) {
      _res = true;
    } else {
      const uu____947 = _0_64;
      {
        const _0_65 = index(s1)(i) == index(s2)(i);
        if (_0_65 == true) {
          _res = eq_i(s1)(s2)(i + 1);
        } else {
          const uu____961 = _0_65;
          _res = false;
        }
      }
    }
  }
  return _res;
};
// const eq =  s1 => s2 => {
//   let _res;
//   {
//     const _0_66 = length(s1) == length(s2);
//     if (_0_66 == true) {
//       _res = eq_i(s1)(s2)(0);
//     } else {
//       const uu____998 = _0_66;
//       _res = false;
//     }
//   }
//   return _res;
// };

const lemma_eq_intro =  s1 => s2 => null;

const lemma_eq_refl =  s1 => s2 => null;

const lemma_eq_elim =  s1 => s2 => null;

//const append_assoc =  s1 => s2 => s3 => null;

const append_empty_l =  s => null;

const append_empty_r =  s => null;"use strict";

 var _Prims = {};

////var Prims = _Prims;

 var _FStar_Seq_Base = {};

//var FStar_Seq_Base = _FStar_Seq_Base;
const lemma_append_inj_l =  s1 => s2 => t1 => t2 => i => null;

const lemma_append_inj_r =  s1 => s2 => t1 => t2 => i => null;

const lemma_append_len_disj =  s1 => s2 => t1 => t2 => null;

const lemma_append_inj =  s1 => s2 => t1 => t2 => null;

const head =  s => FStar_Seq_Base.index(s)(0);

//const tail =  s => FStar_Seq_Base.slice(s)(1)(FStar_Seq_Base.length(s));

const lemma_head_append =  s1 => s2 => null;

const lemma_tail_append =  s1 => s2 => null;

const last =  s => FStar_Seq_Base.index(s)(FStar_Seq_Base.length(s) - 1);

//const cons =  x => s => FStar_Seq_Base.append(FStar_Seq_Base.create(1)(x))(s);

const lemma_cons_inj =  v1 => v2 => s1 => s2 => null;

//const split =  s => i => [FStar_Seq_Base.slice(s)(0)(i), FStar_Seq_Base.slice(s)(i)(FStar_Seq_Base.length(s))];

const lemma_split =  s => i => null;

const split_eq =  s => i => split(s)(i);

// const count =  x => s => {
//   let _res;
//   {
//     const _0_67 = FStar_Seq_Base.length(s) == 0;
//     if (_0_67 == true) {
//       _res = 0;
//     } else {
//       const uu____478 = _0_67;
//       {
//         const _0_68 = head(s) == x;
//         if (_0_68 == true) {
//           _res = 1 + count(x)(tail(s));
//         } else {
//           const uu____485 = _0_68;
//           _res = count(x)(tail(s));
//         }
//       }
//     }
//   }
//   return _res;
// };

//const mem =  x => l => count(x)(l) > 0;

//const swap =  s => i => j => FStar_Seq_Base.upd(FStar_Seq_Base.upd(s)(j)(FStar_Seq_Base.index(s)(i)))(i)(FStar_Seq_Base.index(s)(j));

const lemma_slice_append =  s1 => s2 => null;

const lemma_slice_first_in_append =  s1 => s2 => i => null;

const slice_upd =  s => i => j => k => v => null;

const upd_slice =  s => i => j => k => v => null;

const lemma_append_cons =  s1 => s2 => null;

const lemma_tl =  hd => tl => null;

// const sorted =  f => s => {
//   let _res;
//   {
//     const _0_69 = FStar_Seq_Base.length(s) <= 1;
//     if (_0_69 == true) {
//       _res = true;
//     } else {
//       const uu____815 = _0_69;
//       _res = f(head(s))(FStar_Seq_Base.index(s)(1)) && sorted(f)(tail(s));
//     }
//   }
//   return _res;
// };

const lemma_append_count =  lo => hi => null;

const lemma_append_count_aux =  x => lo => hi => null;

const lemma_mem_inversion =  s => null;

const lemma_mem_count =  s => f => null;

const lemma_count_slice =  s => i => null;

const sorted_concat_lemma =  f => lo => pivot => hi => null;

const split_5 =  s => i => j => {
  let _res;
  {
    const _0_70 = split_eq(s)(i);
    const frag_lo = _0_70[0];
    const rest = _0_70[1];
    {
      const _0_71 = split_eq(rest)(1);
      const frag_i = _0_71[0];
      const rest = _0_71[1];
      {
        const _0_72 = split_eq(rest)(j - (i + 1));
        const frag_mid = _0_72[0];
        const rest = _0_72[1];
        {
          const _0_73 = split_eq(rest)(1);
          const frag_j = _0_73[0];
          const frag_hi = _0_73[1];
          _res = FStar_Seq_Base.upd(FStar_Seq_Base.upd(FStar_Seq_Base.upd(FStar_Seq_Base.upd(FStar_Seq_Base.create(5)(frag_lo))(1)(frag_i))(2)(frag_mid))(3)(frag_j))(4)(frag_hi);
        }
      }
    }
  }
  return _res;
};

const lemma_swap_permutes_aux_frag_eq =  s => i => j => i_ => j_ => null;

const lemma_swap_permutes_aux =  s => i => j => x => null;

const lemma_swap_permutes =  s => i => j => null;

const cons_perm =  tl => s => null;

const lemma_mem_append =  s1 => s2 => null;

const lemma_slice_cons =  s => i => j => null;

const lemma_slice_snoc =  s => i => j => null;

const lemma_ordering_lo_snoc =  f => s => i => j => pv => null;

const lemma_ordering_hi_cons =  f => s => back => len => pv => null;

const swap_frame_lo =  s => lo => i => j => null;

const swap_frame_lo_ =  s => lo => i_ => i => j => null;

const swap_frame_hi =  s => i => j => k => hi => null;

const lemma_swap_slice_commute =  s => start => i => j => len => null;

const lemma_swap_permutes_slice =  s => start => i => j => len => null;

const splice =  s1 => i => s2 => j => FStar_Seq_Base.append(FStar_Seq_Base.slice(s1)(0)(i))(FStar_Seq_Base.append(FStar_Seq_Base.slice(s2)(i)(j))(FStar_Seq_Base.slice(s1)(j)(FStar_Seq_Base.length(s1))));

const splice_refl =  s => i => j => null;

const lemma_swap_splice =  s => start => i => j => len => null;

const lemma_seq_frame_hi =  s1 => s2 => i => j => m => n => null;

const lemma_seq_frame_lo =  s1 => s2 => i => j => m => n => null;

const lemma_tail_slice =  s => i => j => null;

const lemma_weaken_frame_right =  s1 => s2 => i => j => k => null;

const lemma_weaken_frame_left =  s1 => s2 => i => j => k => null;

const lemma_trans_frame =  s1 => s2 => s3 => i => j => null;

const lemma_weaken_perm_left =  s1 => s2 => i => j => k => null;

const lemma_weaken_perm_right =  s1 => s2 => i => j => k => null;

const lemma_trans_perm =  s1 => s2 => s3 => i => j => null;

const snoc =  s => x => FStar_Seq_Base.append(s)(FStar_Seq_Base.create(1)(x));

const lemma_cons_snoc =  hd => s => tl => null;

const lemma_tail_snoc =  s => x => null;

const lemma_snoc_inj =  s1 => s2 => v1 => v2 => null;

const lemma_mem_snoc =  s => x => null;

const find_l =  f => l => {
  let _res;
  {
    const _0_74 = FStar_Seq_Base.length(l) == 0;
    if (_0_74 == true) {
      _res = null;
    } else {
      const uu____3246 = _0_74;
      {
        const _0_75 = f(head(l));
        if (_0_75 == true) {
          _res = head(l);
        } else {
          const uu____3249 = _0_75;
          _res = find_l(f)(tail(l));
        }
      }
    }
  }
  return _res;
};

const find_append_some =  s1 => s2 => f => null;

const find_append_none =  s1 => s2 => f => null;

const find_append_none_s2 =  s1 => s2 => f => null;

const find_snoc =  s => x => f => null;

const un_snoc =  s => {
  let _res;
  {
    const _0_76 = split(s)(FStar_Seq_Base.length(s) - 1);
    const s = _0_76[0];
    const a = _0_76[1];
    _res = [s, FStar_Seq_Base.index(a)(0)];
  }
  return _res;
};

const find_r =  f => l => {
  let _res;
  {
    const _0_77 = FStar_Seq_Base.length(l) == 0;
    if (_0_77 == true) {
      _res = null;
    } else {
      const uu____3465 = _0_77;
      {
        const _0_78 = un_snoc(l);
        const prefix = _0_78[0];
        const last = _0_78[1];
        {
          const _0_79 = f(last);
          if (_0_79 == true) {
            _res = last;
          } else {
            const uu____3474 = _0_79;
            _res = find_r(f)(prefix);
          }
        }
      }
    }
  }
  return _res;
};

const seq_find_aux =  f => l => ctr => {
  let _res;
  {
    const _0_80 = ctr;
    const _0_2 = _0_80;
    if (_0_2 == 0) {
      _res = null;
    } else {
      const uu____3526 = _0_80;
      {
        const _0_81 = f(FStar_Seq_Base.index(l)(ctr - 1));
        if (_0_81 == true) {
          _res = FStar_Seq_Base.index(l)(ctr - 1);
        } else {
          const uu____3534 = _0_81;
          _res = seq_find_aux(f)(l)(ctr - 1);
        }
      }
    }
  }
  return _res;
};

const seq_find =  f => l => seq_find_aux(f)(l)(FStar_Seq_Base.length(l));

const seq_mem_k =  s => n => null;

const seq_to_list =  s => {
  let _res;
  {
    const _0_82 = FStar_Seq_Base.length(s) == 0;
    if (_0_82 == true) {
      _res = [];
    } else {
      const uu____3626 = _0_82;
      _res = [FStar_Seq_Base.index(s)(0)].concat(seq_to_list(FStar_Seq_Base.slice(s)(1)(FStar_Seq_Base.length(s))));
    }
  }
  return _res;
};

const seq_of_list =  l => {
  let _res;
  {
    const _0_83 = l;
    if (_0_83.length == 0) {
      _res = FStar_Seq_Base.createEmpty(null);
    } else {
      if (_0_83.length > 0) {
        const hd = _0_83[0];
        const tl = _0_83.slice(1);
        _res = FStar_Seq_Base.op_At_Bar(FStar_Seq_Base.create(1)(hd))(seq_of_list(tl));
      } else {
        throw "This value doesn\'t match!";
      }
    }
  }
  return _res;
};

const lemma_seq_list_bij =  s => null;

const lemma_list_seq_bij =  l => null;

//const createL =  l => seq_of_list(l);

const lemma_index_is_nth =  s => i => null;

const contains_intro =  s => k => x => null;

const contains_elim =  s => x => null;

const lemma_contains_empty =  null;

const lemma_contains_singleton =  x => null;

const intro_append_contains_from_disjunction = s1 => s2 => x => null;
const append_contains_equiv =  s1 => s2 => x => null;

const contains_snoc =  s => x => null;

const lemma_find_l_contains =  f => l => null;

const contains_cons =  hd => tl => x => null;

const append_cons_snoc =  u => x => v => null;

const append_slices =  s1 => s2 => null;

const find_l_none_no_index =  s => f => null;"use strict";

const strong_excluded_middle =  uu____7 => {
  throw "Not yet implemented!";
};"use strict";"use strict";

//let v =  x => x;

//let zero =  0;
//let one =  1;
//let ones =  4294967295;

//let add =  a => b => a + b;
//let add_underspec =  a => b => add(a)(b);
//let add_mod =  a => b => add(a)(b) & 4294967295;

//let sub =  a => b => a - b;
//let sub_underspec =  a => b => sub(a)(b);
//let sub_mod =  a => b => sub(a)(b) & 4294967295;

//let mul =  a => b => a * b;
//let mul_underspec =  a => b => mul(a)(b);
//let mul_mod =  a => b => mul(a)(b) & 4294967295;

// let div =  a => b => Math.floor(a / b);/

// let rem =  a => b => a % b;

//let logand =  a => b => a & b;
//let logxor =  a => b => a ^ b;
//let logor =  a => b => a | b;
//let lognot =  a => ~a;

let int_to_uint32 =  x => x % 4294967296;

//let shift_right =  a => b => a >>> b;
//let shift_left =  a => b => a << b & 4294967295;

// let gte_mask =  a => b => ~(a - b >> 62) & 255;
// let eq_mask =  a => b => gte_mask(a)(b) & gte_mask(b)(a);

/* Comparison operators */
//let eq =  a => b => a == b;
// let gt =  a => b => a > b;
// let gte =  a => b => a >= b;
// let lt =  a => b => a < b;
// let lte =  a => b => a <= b;

/* Infix notations */
// let op_Plus_Hat =  add;
// let op_Plus_Question_Hat =  add_underspec;
// let op_Plus_Percent_Hat =  add_mod;
// let op_Subtraction_Hat =  sub;
// let op_Subtraction_Question_Hat =  sub_underspec;
// let op_Subtraction_Percent_Hat =  sub_mod;
// let op_Star_Hat =  mul;
// let op_Star_Question_Hat =  mul_underspec;
// let op_Star_Percent_Hat =  mul_mod;
// let op_Slash_Hat =  div;
// let op_Percent_Hat =  rem;
// let op_Hat_Hat =  logxor;
// let op_Amp_Hat =  logand;
// let op_Bar_Hat =  logor;
// let op_Less_Less_Hat =  shift_left;
// let op_Greater_Greater_Hat =  shift_right;
// let op_Equals_Hat =  eq;
// let op_Greater_Hat =  gt;
// let op_Greater_Equals_Hat =  gte;
// let op_Less_Hat =  lt;
// let op_Less_Equals_Hat =  lte;

// let of_string =  s => parseInt(s);
// let to_string =  s => s.toString();
// let to_int =  s => s;
// let uint_to_t =  s => int_to_uint32(s);"use strict";

//let v =  x => x;

let zero =  0;
let one =  1;
let ones =  255;

let add =  a => b => a + b;
let add_underspec =  a => b => add(a)(b);
let add_mod =  a => b => add(a)(b) & 255;

//let sub =  a => b => a - b;
let sub_underspec =  a => b => sub(a)(b);
let sub_mod =  a => b => sub(a)(b) & 255;

let mul =  a => b => a * b;
let mul_underspec =  a => b => mul(a)(b);
let mul_mod =  a => b => mul(a)(b) & 255;

let div =  a => b => Math.floor(a / b);

let rem =  a => b => a % b;

let logand =  a => b => a & b;
let logxor =  a => b => a ^ b;
let logor =  a => b => a | b;
let lognot =  a => ~a;

let int_to_uint8 =  x => x % 256;

let shift_right =  a => b => a >>> b;
let shift_left =  a => b => a << b & 255;

let gte_mask =  a => b => ~(a - b >> 62) & 255;
let eq_mask =  a => b => gte_mask(a)(b) & gte_mask(b)(a);

/* Comparison operators */
//let eq =  a => b => a == b;
let gt =  a => b => a > b;
let gte =  a => b => a >= b;
let lt =  a => b => a < b;
let lte =  a => b => a <= b;

/* Infix notations */
let op_Plus_Hat =  add;
let op_Plus_Question_Hat =  add_underspec;
let op_Plus_Percent_Hat =  add_mod;
let op_Subtraction_Hat =  sub;
let op_Subtraction_Question_Hat =  sub_underspec;
let op_Subtraction_Percent_Hat =  sub_mod;
let op_Star_Hat =  mul;
let op_Star_Question_Hat =  mul_underspec;
let op_Star_Percent_Hat =  mul_mod;
let op_Slash_Hat =  div;
let op_Percent_Hat =  rem;
let op_Hat_Hat =  logxor;
let op_Amp_Hat =  logand;
let op_Bar_Hat =  logor;
let op_Less_Less_Hat =  shift_left;
let op_Greater_Greater_Hat =  shift_right;
let op_Equals_Hat =  eq;
let op_Greater_Hat =  gt;
let op_Greater_Equals_Hat =  gte;
let op_Less_Hat =  lt;
let op_Less_Equals_Hat =  lte;

let of_string =  s => parseInt(s);
let to_string =  s => s.toString();
let to_int =  s => s;
let uint_to_t =  s => int_to_uint8(s);