"use strict";

let uint8_to_uint64 =  a => a;

let uint8_to_uint63 =  a => a;
let uint8_to_uint32 =  a => a;
let uint8_to_uint16 =  a => a;

let uint16_to_uint64 =  a => a;
let uint16_to_uint63 =  a => a;
let uint16_to_uint32 =  a => a;
let uint16_to_uint8 =  a => a & 255;

let uint32_to_uint64 =  a => a;
let uint32_to_uint63 =  a => a;
let uint32_to_uint16 =  a => a & 65535;
let uint32_to_uint8 =  a => a & 255;

let uint63_to_uint64 =  a => a;
let uint63_to_uint32 =  a => a & 4294967295;
let uint63_to_uint16 =  a => a & 65535;
let uint63_to_uint8 =  a => a & 255;

let uint64_to_uint63 =  a => a;
let uint64_to_uint32 =  a => a & 4294967295;
let uint64_to_uint16 =  a => a & 65535;
let uint64_to_uint8 =  a => a & 255;

/* Ints to Ints */
let int8_to_int64 =  a => a;
let int8_to_int63 =  a => a;
let int8_to_int32 =  a => a;
let int8_to_int16 =  a => a;

let int16_to_int64 =  a => a;
let int16_to_int63 =  a => a;
let int16_to_int32 =  a => a;
let int16_to_int8 =  a => a & 255;

let int32_to_int64 =  a => a;
let int32_to_int63 =  a => a;
let int32_to_int16 =  a => a & 65535;
let int32_to_int8 =  a => a & 255;

let int63_to_int64 =  a => a;
let int63_to_int32 =  a => a & 4294967295;
let int63_to_int16 =  a => a & 65535;
let int63_to_int8 =  a => a & 255;

let int64_to_int63 =  a => a;
let int64_to_int32 =  a => a & 4294967295;
let int64_to_int16 =  a => a & 65535;
let int64_to_int8 =  a => a & 255;

/* Uints to Ints */
let uint8_to_int64 =  a => a;
let uint8_to_int63 =  a => a;
let uint8_to_int32 =  a => a;
let uint8_to_int16 =  a => a;
let uint8_to_int8 =  a => a;

let uint16_to_int64 =  a => a;
let uint16_to_int63 =  a => a;
let uint16_to_int32 =  a => a;
let uint16_to_int16 =  a => a;
let uint16_to_int8 =  a => a & 255;

let uint32_to_int64 =  a => a;
let uint32_to_int63 =  a => a;
let uint32_to_int32 =  a => a;
let uint32_to_int16 =  a => a & 65535;
let uint32_to_int8 =  a => a & 255;

let uint63_to_int64 =  a => a;
let uint63_to_int63 =  a => a;
let uint63_to_int32 =  a => a & 4294967295;
let uint63_to_int16 =  a => a & 65535;
let uint63_to_int8 =  a => a & 255;

let uint64_to_int64 =  a => a;
let uint64_to_int63 =  a => a;
let uint64_to_int32 =  a => a & 4294967295;
let uint64_to_int16 =  a => a & 65535;
let uint64_to_int8 =  a => a & 255;

/* Ints to uints */
let int8_to_uint64 =  a => a;
let int8_to_uint63 =  a => a;
let int8_to_uint32 =  a => a;
let int8_to_uint16 =  a => a;
let int8_to_uint8 =  a => a;

let int16_to_uint64 =  a => a;
let int16_to_uint63 =  a => a;
let int16_to_uint32 =  a => a;
let int16_to_uint16 =  a => a;
let int16_to_uint8 =  a => a & 255;

let int32_to_uint64 =  a => a;
let int32_to_uint63 =  a => a;
let int32_to_uint32 =  a => a;
let int32_to_uint16 =  a => a & 65535;
let int32_to_uint8 =  a => a & 255;

let int63_to_uint64 =  a => a;
let int63_to_uint63 =  a => a;
let int63_to_uint32 =  a => a & 4294967295;
let int63_to_uint16 =  a => a & 65535;
let int63_to_uint8 =  a => a & 255;

let int64_to_uint64 =  a => a;
let int64_to_uint63 =  a => a;
let int64_to_uint32 =  a => a & 4294967295;
let int64_to_uint16 =  a => a & 65535;
let int64_to_uint8 =  a => a & 255;

let uint128_to_uint64 =  a => a;
let uint64_to_uint128 =  a => a;