(function (ds) {
    ds._o_057.create = plugin => {
        let _res;
        {
            let _crypto = null;
            var _v_023 = {
                plugin: plugin,
                key: null,
                seed: null,
                time: null,
                reseeds: 0,
                generated: 0
            };
            let md = plugin.md;
            const _c_190 = new Array(32);
            for (let i = 0; i < 32; ++i) {
                _c_190[i] = md.create();
            }
            _v_023.pools = _c_190;
            _v_023.pool = 0;
            _v_023.generate = function (count, callback) {
                let _res;
                {
                    if (!callback) {
                        return _v_023._f_280(count);
                    }
                    var cipher = _v_023.plugin.cipher;
                    var increment = _v_023.plugin.increment;
                    var formatKey = _v_023.plugin.formatKey;
                    var formatSeed = _v_023.plugin.formatSeed;
                    var _v_017 = ds._o_059._f_125();
                    _v_023.key = null;
                    function _f_281(err) {
                        let _res;
                        {
                            if (err) {
                                return callback(err);
                            }
                            if (_v_017.length() >= count) {
                                return callback(null, _v_017.getBytes(count));
                            }
                            if (_v_023.generated > 1048575) {
                                _v_023.key = null;
                            }
                            if (_v_023.key === null) {
                                return ds._o_050._f_140(function () {
                                    let _res;
                                    {
                                        _f_283(_f_281);
                                    }
                                });
                            }
                            var _v_018 = cipher(_v_023.key, _v_023.seed);
                            _v_023.generated += _v_018.length;
                            _v_017._f_127(_v_018);
                            _v_023.key = formatKey(cipher(_v_023.key, increment(_v_023.seed)));
                            _v_023.seed = formatSeed(cipher(_v_023.key, _v_023.seed));
                            ds._o_050._f_141(_f_281);
                        }
                    }
                    _f_281();
                }
            };
            _v_023._f_280 = function (count) {
                let _res;
                {
                    let cipher = _v_023.plugin.cipher;
                    let increment = _v_023.plugin.increment;
                    let formatKey = _v_023.plugin.formatKey;
                    let formatSeed = _v_023.plugin.formatSeed;
                    _v_023.key = null;
                    let b = ds._o_059._f_125();
                    while (b.length() < count) {
                        if (_v_023.generated > 1048575) {
                            _v_023.key = null;
                        }
                        if (_v_023.key === null) {
                            _f_284();
                        }
                        let bytes = cipher(_v_023.key, _v_023.seed);
                        _v_023.generated += bytes.length;
                        b._f_127(bytes);
                        _v_023.key = formatKey(cipher(_v_023.key, increment(_v_023.seed)));
                        _v_023.seed = formatSeed(cipher(_v_023.key, _v_023.seed));
                    }
                    return b.getBytes(count);
                }
            };
            function _f_282() {
                let _res;
                {
                    let md = _v_023.plugin.md.create();
                    md.update(_v_023.pools[0].digest().getBytes());
                    _v_023.pools[0].start();
                    let k = 1;
                    for (let i = 1; i < 32; ++i) {
                        k = k === 31 ? 2147483648 : k << 2;
                        if (k % _v_023.reseeds === 0) {
                            md.update(_v_023.pools[i].digest().getBytes());
                            _v_023.pools[i].start();
                        }
                    }
                    let keyBytes = md.digest().getBytes();
                    md.start();
                    md.update(keyBytes);
                    let seedBytes = md.digest().getBytes();
                    _v_023.key = _v_023.plugin.formatKey(keyBytes);
                    _v_023.seed = _v_023.plugin.formatSeed(seedBytes);
                    _v_023.reseeds = _v_023.reseeds === 4294967295 ? 0 : _v_023.reseeds + 1;
                    _v_023.generated = 0;
                }
            }
            function _f_283(callback) {
                let _res;
                {
                    if (_v_023.pools[0].messageLength >= 32) {
                        _f_282();
                        return callback();
                    }
                    let needed = 32 - _v_023.pools[0].messageLength << 5;
                    _v_023.seedFile(needed, function (err, bytes) {
                        let _res;
                        {
                            if (err) {
                                return callback(err);
                            }
                            _v_023.collect(bytes);
                            _f_282();
                            callback();
                        }
                    });
                }
            }
            function _f_284() {
                let _res;
                {
                    if (_v_023.pools[0].messageLength >= 32) {
                        return _f_282();
                    }
                    let needed = 32 - _v_023.pools[0].messageLength << 5;
                    _v_023.collect(_v_023.seedFileSync(needed));
                    _f_282();
                }
            }
            function _f_285(needed) {
                let _res;
                {
                    let getRandomValues = null;
                    if (typeof window !== 'undefined') {
                        let _crypto = window.crypto || window.msCrypto;
                        if (_crypto && _crypto.getRandomValues) {
                            getRandomValues = function (arr) {
                                let _res;
                                {
                                    return _crypto.getRandomValues(arr);
                                }
                            };
                        }
                    }
                    let b = ds._o_059._f_125();
                    if (getRandomValues) {
                        while (b.length() < needed) {
                            let count = Math.max(1, Math.min(needed - b.length(), 65536) / 4);
                            let entropy = new Uint32Array(Math.floor(count));
                            try {
                                getRandomValues(entropy);
                                for (let i = 0; i < entropy.length; ++i) {
                                    b._f_134(entropy[i]);
                                }
                            } catch (e) {
                                if (!(typeof QuotaExceededError !== 'undefined' && e instanceof QuotaExceededError)) {
                                    throw e;
                                }
                            }
                        }
                    }
                    if (b.length() < needed) {
                        let hi, lo, next;
                        let seed = Math.floor(Math.random() * 65536);
                        while (b.length() < needed) {
                            lo = 16807 * (seed & 65535);
                            hi = 16807 * (seed >> 16);
                            lo += (hi & 32767) << 16;
                            lo += hi >> 15;
                            lo = (lo & 2147483647) + (lo >> 31);
                            seed = lo & 4294967295;
                            for (let i = 0; i < 3; ++i) {
                                next = seed >>> (i << 3);
                                next ^= Math.floor(Math.random() * 256);
                                b._f_128(String.fromCharCode(next & 255));
                            }
                        }
                    }
                    return b.getBytes(needed);
                }
            }
            if (_crypto) {
                _v_023.seedFile = function (needed, callback) {
                    let _res;
                    {
                        _crypto.randomBytes(needed, function (err, bytes) {
                            let _res;
                            {
                                if (err) {
                                    return callback(err);
                                }
                                callback(null, bytes.toString());
                            }
                        });
                    }
                };
                _v_023.seedFileSync = function (needed) {
                    let _res;
                    {
                        return _crypto.randomBytes(needed).toString();
                    }
                };
            } else {
                _v_023.seedFile = function (needed, callback) {
                    let _res;
                    {
                        try {
                            callback(null, _f_285(needed));
                        } catch (e) {
                            callback(e);
                        }
                    }
                };
                _v_023.seedFileSync = _f_285;
            }
            _v_023.collect = function (bytes) {
                let _res;
                {
                    const count = bytes.length;
                    for (let i = 0; i < count; ++i) {
                        _v_023.pools[_v_023.pool].update(bytes.substr(i, 1));
                        _v_023.pool = _v_023.pool === 31 ? 0 : _v_023.pool + 1;
                    }
                }
            };
            _v_023.collectInt = function (i, n) {
                let _res;
                {
                    let bytes = '';
                    for (let x = 0; x < n; x += 8) {
                        bytes += String.fromCharCode(i >> x & 255);
                    }
                    _v_023.collect(bytes);
                }
            };
            return _v_023;
        }
    };
}(ds));
