(function (ds) {
    ds._o_051._f_150 = (m, key, bt) => {
        let _res;
        {
            let eb = ds._o_059._f_125();
            const k = Math.ceil(key.n.bitLength() / 8);
            eb._f_128(0);
            eb._f_128(bt);
            const padNum = k - 3 - m.length;
            let padByte;
            if (bt === 0 || bt === 1) {
                padByte = bt === 0 ? 0 : 255;
                for (let i = 0; i < padNum; ++i) {
                    eb._f_128(padByte);
                }
            } else {
                while (padNum > 0) {
                    let numZeros = 0;
                    let padBytes = ds._o_055.getBytes(padNum);
                    for (let i = 0; i < padNum; ++i) {
                        padByte = padBytes.charCodeAt(i);
                        if (padByte === 0) {
                            ++numZeros;
                        } else {
                            eb._f_128(padByte);
                        }
                    }
                    padNum = numZeros;
                }
            }
            eb._f_128(0);
            eb._f_127(m);
            return eb;
        }
    };
    ds._o_051._f_151 = md => {
        let _res;
        {
            let oid = '2.16.840.1.101.3.4.2.1';
            let oidBytes = ds._o_058._f_303(oid).getBytes();
            var digestInfo = ds._o_058._f_300(ds._o_058._O_045._c_161, ds._o_058._O_046._c_179, true, []);
            let digestAlgorithm = ds._o_058._f_300(ds._o_058._O_045._c_161, ds._o_058._O_046._c_179, true, []);
            digestAlgorithm.value.push(ds._o_058._f_300(ds._o_058._O_045._c_161, ds._o_058._O_046._c_171, false, oidBytes));
            digestAlgorithm.value.push(ds._o_058._f_300(ds._o_058._O_045._c_161, ds._o_058._O_046._c_170, false, ''));
            let digest = ds._o_058._f_300(ds._o_058._O_045._c_161, ds._o_058._O_046._c_169, false, md.digest().getBytes());
            digestInfo.value.push(digestAlgorithm);
            digestInfo.value.push(digest);
            return ds._o_058._f_302(digestInfo).getBytes();
        }
    };
    const _c_125 = function (x, key, pub) {
        let _res;
        {
            if (pub) {
                return x._f_234(key.e, key.n);
            }
            return x._f_234(key.d, key.n);
        }
    };
    ds._o_051._f_152 = (em, key, pub, ml) => {
        let _res;
        {
            const k = Math.ceil(key.n.bitLength() / 8);
            let eb = ds._o_059._f_125(em);
            const first = eb._f_131();
            const bt = eb._f_131();
            if (first !== 0 || pub && bt !== 0 && bt !== 1 || !pub && bt != 2 || pub && bt === 0 && typeof ml === 'undefined') {
                throw new Error('Encryption block is invalid.');
            }
            let padNum = 0;
            if (bt === 0) {
                padNum = k - 3 - ml;
                if (eb._f_131() !== 0) {
                    throw new Error('Encryption block is invalid.');
                }
            } else if (bt === 1) {
                padNum = 0;
                while (eb.length() > 1) {
                    if (eb._f_131() !== 255) {
                        --eb.read;
                        break;
                    }
                    ++padNum;
                }
            } else if (bt === 2) {
                padNum = 0;
                while (eb.length() > 1) {
                    if (eb._f_131() === 0) {
                        --eb.read;
                        break;
                    }
                    ++padNum;
                }
            }
            const zero = eb._f_131();
            if (zero !== 0 || padNum !== k - 3 - eb.length()) {
                throw new Error('Encryption block is invalid.');
            }
            return eb.getBytes();
        }
    };
    ds._o_051._f_153 = (m, key, bt) => {
        let _res;
        {
            let pub = bt;
            let eb;
            const k = Math.ceil(key.n.bitLength() / 8);
            if (bt !== false && bt !== true) {
                pub = bt === 2;
                eb = ds._o_051._f_150(m, key, bt);
            } else {
                eb = ds._o_059._f_125();
                eb._f_127(m);
            }
            const x = ds._o_052._f_204(eb._f_129(), 16);
            const y = _c_125(x, key, pub);
            let yhex = y.toString(16);
            let ed = ds._o_059._f_125();
            let zeros = k - Math.ceil(yhex.length / 2);
            while (zeros > 0) {
                ed._f_128(0);
                --zeros;
            }
            ed._f_127(ds._o_050._f_146(yhex));
            return ed.getBytes();
        }
    };
    ds._o_051._f_154 = (ed, key, pub, ml) => {
        let _res;
        {
            const k = Math.ceil(key.n.bitLength() / 8);
            if (ed.length !== k) {
                let error = new Error('Encrypted message length is invalid.');
                error.length = ed.length;
                error.expected = k;
                throw error;
            }
            let y = ds._o_052._f_204(ds._o_059._f_125(ed)._f_129(), 16);
            if (y._f_222(key.n) >= 0) {
                throw new Error('Encrypted message is invalid.');
            }
            let x = _c_125(y, key, pub);
            const xhex = x.toString(16);
            let eb = ds._o_059._f_125();
            let zeros = k - Math.ceil(xhex.length / 2);
            while (zeros > 0) {
                eb._f_128(0);
                --zeros;
            }
            eb._f_127(ds._o_050._f_146(xhex));
            if (ml !== false) {
                return ds._o_051._f_152(eb.getBytes(), key, pub);
            }
            return eb.getBytes();
        }
    };
}(ds));
