
(function(ds){

    (() => {
        if(typeof process !== 'undefined' && process.nextTick) {
            ds._o_050._f_140 = process.nextTick;
            if(typeof setImmediate === 'function') {
                ds._o_050._f_141 = setImmediate;
            } else {
                ds._o_050._f_141 = ds._o_050._f_140;
            }
            return;
        }

        if(typeof setImmediate === 'function') {
            ds._o_050._f_141 = () => { return setImmediate.apply(undefined, arguments); };
            ds._o_050._f_140 = (callback) => {
                return setImmediate(callback);
            };
            return;
        }

        ds._o_050._f_141 = (callback) => {
            setTimeout(callback, 0);
        };

        if(typeof window !== 'undefined' &&
            typeof window.postMessage === 'function') {
            let msg = 'ds.setImmediate';
            let callbacks = [];
            ds._o_050._f_141 = (callback) => {
                callbacks.push(callback);
                if(callbacks.length === 1) {
                    window.postMessage(msg, '*');
                }
            };
            function handler(event) {
                if(event.source === window && event.data === msg) {
                    event.stopPropagation();
                    let copy = callbacks.slice();
                    callbacks.length = 0;
                    copy.forEach(function(callback) {
                        callback();
                    });
                }
            }
            window.addEventListener('message', handler, true);
        }

        if(typeof MutationObserver !== 'undefined') {
            var now = Date.now();
            var attr = true;
            var div = document.createElement('div');
            var callbacks = [];
            new MutationObserver(function() {
                let copy = callbacks.slice();
                callbacks.length = 0;
                copy.forEach(function(callback) {
                    callback();
                });
            }).observe(div, {attributes: true});
            var oldSetImmediate = ds._o_050._f_141;
            ds._o_050._f_141 = function(callback) {
                if(Date.now() - now > 15) {
                    now = Date.now();
                    oldSetImmediate(callback);
                } else {
                    callbacks.push(callback);
                    if(callbacks.length === 1) {
                        div.setAttribute('a', attr = !attr);
                    }
                }
            };
        }

        ds._o_050._f_140 = ds._o_050._f_141;
    })();

    ds._o_050._f_143 = (x) => {
        return typeof ArrayBuffer !== 'undefined' && x instanceof ArrayBuffer;
    };

    ds._o_050._f_142 = (x) => {
        return x && utils.isArrayBuffer(x.buffer) && x.byteLength !== undefined;
    };

    ds._o_050._f_144 = Array.isArray || function(x) {
        return Object.prototype.toString.call(x) === '[object Array]';
    };

    ds._o_050._f_145 = (str) => {
        return unescape(encodeURIComponent(str));
    };

    ds._o_050._f_146 = (hex) => {
        let rval = '';
        let i = 0;
        if(hex.length & 1 == 1) {
          i = 1;
          rval += String.fromCharCode(parseInt(hex[0], 16));
        }
        for(; i < hex.length; i += 2) {
          rval += String.fromCharCode(parseInt(hex.substr(i, 2), 16));
        }
        return rval;
    };

    ds._o_050._f_147 = (c, n) => {
        let s = '';
        while(n > 0) {
            if(n & 1) {
                s += c;
            }
            n >>>= 1;
            if(n > 0) {
                c += c;
            }
        }
        return s;
    };

})(ds);
